(* ----------------------------------------------------------------------------- *) 
(* This model file was automatically created by SARAH version4.6.0  *) 
(* SARAH References: arXiv:0806.0538, 0909.2863, 1002.0840, 1207.0906, 1309.7223 *) 
(* (c) Florian Staub, 2013  *) 
(* ----------------------------------------------------------------------------- *) 
(* File created at 21:53 on 18.11.2015  *) 
(* ---------------------------------------------------------------------- *) 
 
 
IndexRange[  Index[Colour]  ] =NoUnfold[Range[3]]; 
IndexStyle[  Index[Colour, i_Integer ] ] := Greek[i];  
IndexRange[  Index[I2Gen]  ] =Range[2]; 
IndexStyle[  Index[I2Gen, i_Integer ] ] := Alph[ 8+i];  
IndexRange[  Index[I3Gen]  ] =Range[3]; 
IndexStyle[  Index[I3Gen, i_Integer ] ] := Alph[ 8+i];  
IndexRange[  Index[I4Gen]  ] =Range[4]; 
IndexStyle[  Index[I4Gen, i_Integer ] ] := Alph[ 8+i];  
IndexRange[  Index[Gluon]  ] =NoUnfold[Range[8]]; 
IndexStyle[  Index[Gluon, i_Integer ] ] := Alph[ 8+i];  

 
(* Definitions for trigonometric functions  
Sin[ThetaW]: STW
Sin[2*ThetaW]: S2TW
Cos[ThetaW]: CTW
Cos[2*ThetaW]: C2TW
*) 
 
Conjugate[STW] ^= STW
Conjugate[S2TW] ^= S2TW
Conjugate[CTW] ^= CTW
Conjugate[C2TW] ^= C2TW
 
 
Lam[a_,b_,c_]:=2*SUNT[a,b,c]; 
fSU3[a_,b_,c_]:=SUNF[a,b,c]; 
LambdaProd[a_,b_][c_,d_]:=4*SUNT[a,b,c,d]; 
 
 
M$ClassesDescription= {
S[1] == {SelfConjugate -> True,
Indices -> {Index[I4Gen]},
Mass -> Masshh,
PropagatorLabel->ComposedChar["h",Index[I4Gen]],
PropagatorType -> ScalarDash,
PropagatorArrow -> None},

 
S[3] == {SelfConjugate -> False,
Indices -> {Index[I2Gen]},
Mass -> MassHm,
PropagatorLabel->ComposedChar["H",Index[I2Gen],"-"],
PropagatorType -> ScalarDash,
PropagatorArrow -> Forward},

 
F[1] == {SelfConjugate -> False,
Indices -> {Index[I3Gen]},
Mass -> MassFv,
PropagatorLabel->ComposedChar["\\nu",Index[I3Gen]],
PropagatorType -> Straight,
PropagatorArrow -> Forward},

 
F[4] == {SelfConjugate -> False,
Indices -> {Index[I3Gen], Index[Colour]},
Mass -> MassFd,
PropagatorLabel->ComposedChar["d",Index[I3Gen],Index[Colour]],
PropagatorType -> Straight,
PropagatorArrow -> Forward},

 
F[3] == {SelfConjugate -> False,
Indices -> {Index[I3Gen], Index[Colour]},
Mass -> MassFu,
PropagatorLabel->ComposedChar["u",Index[I3Gen],Index[Colour]],
PropagatorType -> Straight,
PropagatorArrow -> Forward},

 
F[2] == {SelfConjugate -> False,
Indices -> {Index[I3Gen]},
Mass -> MassFe,
PropagatorLabel->ComposedChar["e",Index[I3Gen]],
PropagatorType -> Straight,
PropagatorArrow -> Forward},

 
V[5] == {SelfConjugate -> True,
Indices -> {Index[Gluon]},
Mass -> 0,
PropagatorLabel->ComposedChar["g",Index[Gluon]],
PropagatorType -> Sine,
PropagatorArrow -> None},

 
V[1] == {SelfConjugate -> True,
Indices -> {},
Mass -> 0,
PropagatorLabel->ComposedChar["\\gamma"],
PropagatorType -> Sine,
PropagatorArrow -> None},

 
V[2] == {SelfConjugate -> True,
Indices -> {},
Mass -> MassVZ,
PropagatorLabel->ComposedChar["Z"],
PropagatorType -> Sine,
PropagatorArrow -> None},

 
V[3] == {SelfConjugate -> False,
Indices -> {},
Mass -> MassVWm,
PropagatorLabel->ComposedChar["W","-"],
PropagatorType -> Sine,
PropagatorArrow -> Forward},

 
U[5] == {SelfConjugate -> False,
Indices -> {Index[Gluon]},
Mass -> 0,
PropagatorLabel->ComposedChar["\\eta",Index[Gluon],"G"],
PropagatorType -> GhostDash,
PropagatorArrow -> Forward},

 
U[1] == {SelfConjugate -> False,
Indices -> {},
Mass -> 0,
PropagatorLabel->ComposedChar["\\eta","\\gamma"],
PropagatorType -> GhostDash,
PropagatorArrow -> Forward},

 
U[2] == {SelfConjugate -> False,
Indices -> {},
Mass -> MassVZ,
PropagatorLabel->ComposedChar["\\eta","Z"],
PropagatorType -> GhostDash,
PropagatorArrow -> Forward},

 
U[3] == {SelfConjugate -> False,
Indices -> {},
Mass -> MassVWm,
PropagatorLabel->ComposedChar["\\eta","-"],
PropagatorType -> GhostDash,
PropagatorArrow -> Forward},

 
U[4] == {SelfConjugate -> False,
Indices -> {},
Mass -> MassVWm,
PropagatorLabel->ComposedChar["\\eta","+"],
PropagatorType -> GhostDash,
PropagatorArrow -> Forward}
 
}

 
MassFd[gen_, y_] = MassFd[gen]
MassFu[gen_, y_] = MassFu[gen]


GaugeXi[S[1,{a_Integer}]] = 1 /; a > 1 
GaugeXi[S[1,1]] = GaugeXi[VZ] /; a > 1 
GaugeXi[S[3,{a_Integer}]] = 1 /; a > 1 
GaugeXi[S[3,1]] = GaugeXi[VWm] /; a > 1 


GaugeXi[V[5,___]] = GaugeXi[G]
GaugeXi[V[1,___]] = GaugeXi[P]
GaugeXi[V[2,___]] = GaugeXi[Z]
GaugeXi[V[3,___]] = GaugeXi[Wm]


M$CouplingMatrices= {
C[V[5, {ct1}], V[5, {ct2}], V[5, {ct3}], V[5, {ct4}]] == {{(-I)*g3^2*(fSU3[1, ct1, ct4]*fSU3[1, ct2, ct3] + fSU3[1, ct1, ct3]*fSU3[1, ct2, ct4] + fSU3[2, ct1, ct4]*fSU3[2, ct2, ct3] + fSU3[2, ct1, ct3]*fSU3[2, ct2, ct4] + fSU3[3, ct1, ct4]*fSU3[3, ct2, ct3] + fSU3[3, ct1, ct3]*fSU3[3, ct2, ct4] + fSU3[4, ct1, ct4]*fSU3[4, ct2, ct3] + fSU3[4, ct1, ct3]*fSU3[4, ct2, ct4] + fSU3[5, ct1, ct4]*fSU3[5, ct2, ct3] + fSU3[5, ct1, ct3]*fSU3[5, ct2, ct4] + fSU3[6, ct1, ct4]*fSU3[6, ct2, ct3] + fSU3[6, ct1, ct3]*fSU3[6, ct2, ct4] + fSU3[7, ct1, ct4]*fSU3[7, ct2, ct3] + fSU3[7, ct1, ct3]*fSU3[7, ct2, ct4] + fSU3[8, ct1, ct4]*fSU3[8, ct2, ct3] + fSU3[8, ct1, ct3]*fSU3[8, ct2, ct4])}, {I*g3^2*(fSU3[1, ct1, ct4]*fSU3[1, ct2, ct3] - fSU3[1, ct1, ct2]*fSU3[1, ct3, ct4] + fSU3[2, ct1, ct4]*fSU3[2, ct2, ct3] - fSU3[2, ct1, ct2]*fSU3[2, ct3, ct4] + fSU3[3, ct1, ct4]*fSU3[3, ct2, ct3] - fSU3[3, ct1, ct2]*fSU3[3, ct3, ct4] + fSU3[4, ct1, ct4]*fSU3[4, ct2, ct3] - fSU3[4, ct1, ct2]*fSU3[4, ct3, ct4] + fSU3[5, ct1, ct4]*fSU3[5, ct2, ct3] - fSU3[5, ct1, ct2]*fSU3[5, ct3, ct4] + fSU3[6, ct1, ct4]*fSU3[6, ct2, ct3] - fSU3[6, ct1, ct2]*fSU3[6, ct3, ct4] + fSU3[7, ct1, ct4]*fSU3[7, ct2, ct3] - fSU3[7, ct1, ct2]*fSU3[7, ct3, ct4] + fSU3[8, ct1, ct4]*fSU3[8, ct2, ct3] - fSU3[8, ct1, ct2]*fSU3[8, ct3, ct4])}, {I*g3^2*(fSU3[1, ct1, ct3]*fSU3[1, ct2, ct4] + fSU3[1, ct1, ct2]*fSU3[1, ct3, ct4] + fSU3[2, ct1, ct3]*fSU3[2, ct2, ct4] + fSU3[2, ct1, ct2]*fSU3[2, ct3, ct4] + fSU3[3, ct1, ct3]*fSU3[3, ct2, ct4] + fSU3[3, ct1, ct2]*fSU3[3, ct3, ct4] + fSU3[4, ct1, ct3]*fSU3[4, ct2, ct4] + fSU3[4, ct1, ct2]*fSU3[4, ct3, ct4] + fSU3[5, ct1, ct3]*fSU3[5, ct2, ct4] + fSU3[5, ct1, ct2]*fSU3[5, ct3, ct4] + fSU3[6, ct1, ct3]*fSU3[6, ct2, ct4] + fSU3[6, ct1, ct2]*fSU3[6, ct3, ct4] + fSU3[7, ct1, ct3]*fSU3[7, ct2, ct4] + fSU3[7, ct1, ct2]*fSU3[7, ct3, ct4] + fSU3[8, ct1, ct3]*fSU3[8, ct2, ct4] + fSU3[8, ct1, ct2]*fSU3[8, ct3, ct4])}},
 C[-V[3], V[1], V[1], V[3]] == {{I*g2^2*STW^2}, {I*g2^2*STW^2}, {(-2*I)*g2^2*STW^2}},
 C[-V[3], V[1], V[3], V[2]] == {{I*CTW*g2^2*STW}, {(-I)*g2^2*S2TW}, {I*CTW*g2^2*STW}},
 C[-V[3], -V[3], V[3], V[3]] == {{(2*I)*g2^2}, {(-I)*g2^2}, {(-I)*g2^2}},
 C[-V[3], V[3], V[2], V[2]] == {{(-2*I)*CTW^2*g2^2}, {I*CTW^2*g2^2}, {I*CTW^2*g2^2}},
 C[S[1, {gt1}], S[1, {gt2}], -V[3], V[3]] == {{(I/2)*g2^2*(ZH[gt1, 1]*ZH[gt2, 1] + ZH[gt1, 2]*ZH[gt2, 2] + ZH[gt1, 3]*ZH[gt2, 3] + ZH[gt1, 4]*ZH[gt2, 4])}},
 C[S[1, {gt1}], S[1, {gt2}], V[2], V[2]] == {{(I/2)*(CTW*g2 + g1*STW)^2*(ZH[gt1, 1]*ZH[gt2, 1] + ZH[gt1, 2]*ZH[gt2, 2] + ZH[gt1, 3]*ZH[gt2, 3] + ZH[gt1, 4]*ZH[gt2, 4])}},
 C[S[1, {gt1}], S[3, {gt2}], -V[3], V[1]] == {{(I/2)*CTW*g1*g2*(Conjugate[ZP[gt2, 1]]*(ZH[gt1, 1] + I*ZH[gt1, 3]) + Conjugate[ZP[gt2, 2]]*(ZH[gt1, 2] + I*ZH[gt1, 4]))}},
 C[S[1, {gt1}], S[3, {gt2}], -V[3], V[2]] == {{(g1*g2*STW*(Conjugate[ZP[gt2, 1]]*((-I)*ZH[gt1, 1] + ZH[gt1, 3]) + Conjugate[ZP[gt2, 2]]*((-I)*ZH[gt1, 2] + ZH[gt1, 4])))/2}},
 C[S[1, {gt1}], -S[3, {gt2}], V[1], V[3]] == {{(CTW*g1*g2*(I*ZH[gt1, 1]*ZP[gt2, 1] + ZH[gt1, 3]*ZP[gt2, 1] + (I*ZH[gt1, 2] + ZH[gt1, 4])*ZP[gt2, 2]))/2}},
 C[S[1, {gt1}], -S[3, {gt2}], V[3], V[2]] == {{(-I/2)*g1*g2*STW*(ZH[gt1, 1]*ZP[gt2, 1] - I*ZH[gt1, 3]*ZP[gt2, 1] + (ZH[gt1, 2] - I*ZH[gt1, 4])*ZP[gt2, 2])}},
 C[S[3, {gt1}], -S[3, {gt2}], V[1], V[1]] == {{(I/2)*(CTW*g1 + g2*STW)^2*(Conjugate[ZP[gt1, 1]]*ZP[gt2, 1] + Conjugate[ZP[gt1, 2]]*ZP[gt2, 2])}},
 C[S[3, {gt1}], -S[3, {gt2}], V[1], V[2]] == {{(-I/4)*(-2*C2TW*g1*g2 + (g1^2 - g2^2)*S2TW)*(Conjugate[ZP[gt1, 1]]*ZP[gt2, 1] + Conjugate[ZP[gt1, 2]]*ZP[gt2, 2])}},
 C[S[3, {gt1}], -S[3, {gt2}], -V[3], V[3]] == {{(I/2)*g2^2*(Conjugate[ZP[gt1, 1]]*ZP[gt2, 1] + Conjugate[ZP[gt1, 2]]*ZP[gt2, 2])}},
 C[S[3, {gt1}], -S[3, {gt2}], V[2], V[2]] == {{(I/2)*(CTW*g2 - g1*STW)^2*(Conjugate[ZP[gt1, 1]]*ZP[gt2, 1] + Conjugate[ZP[gt1, 2]]*ZP[gt2, 2])}},
 C[-F[4, {gt1, ct1}], F[4, {gt2, ct2}], S[1, {gt3}]] == {{((-I)*IndexDelta[ct1, ct2]*((Conjugate[ZDL[gt2, 1]]*(Conjugate[ZDR[gt1, 1]]*Yd[1, 1] + Conjugate[ZDR[gt1, 2]]*Yd[2, 1] + Conjugate[ZDR[gt1, 3]]*Yd[3, 1]) + Conjugate[ZDL[gt2, 2]]*(Conjugate[ZDR[gt1, 1]]*Yd[1, 2] + Conjugate[ZDR[gt1, 2]]*Yd[2, 2] + Conjugate[ZDR[gt1, 3]]*Yd[3, 2]) + Conjugate[ZDL[gt2, 3]]*(Conjugate[ZDR[gt1, 1]]*Yd[1, 3] + Conjugate[ZDR[gt1, 2]]*Yd[2, 3] + Conjugate[ZDR[gt1, 3]]*Yd[3, 3]))*(ZH[gt3, 1] - I*ZH[gt3, 3]) + E^(I*"eta")*(Conjugate[ZDL[gt2, 1]]*(Conjugate[ZDR[gt1, 1]]*epsD[1, 1] + Conjugate[ZDR[gt1, 2]]*epsD[2, 1] + Conjugate[ZDR[gt1, 3]]*epsD[3, 1]) + Conjugate[ZDL[gt2, 2]]*(Conjugate[ZDR[gt1, 1]]*epsD[1, 2] + Conjugate[ZDR[gt1, 2]]*epsD[2, 2] + Conjugate[ZDR[gt1, 3]]*epsD[3, 2]) + Conjugate[ZDL[gt2, 3]]*(Conjugate[ZDR[gt1, 1]]*epsD[1, 3] + Conjugate[ZDR[gt1, 2]]*epsD[2, 3] + Conjugate[ZDR[gt1, 3]]*epsD[3, 3]))*(ZH[gt3, 2] - I*ZH[gt3, 4])))/(Sqrt[2]*E^(I*"eta"))}, {(IndexDelta[ct1, ct2]*(E^(I*"eta")*(ZDL[gt1, 1]*(Conjugate[Yd[1, 1]]*ZDR[gt2, 1] + Conjugate[Yd[2, 1]]*ZDR[gt2, 2] + Conjugate[Yd[3, 1]]*ZDR[gt2, 3]) + ZDL[gt1, 2]*(Conjugate[Yd[1, 2]]*ZDR[gt2, 1] + Conjugate[Yd[2, 2]]*ZDR[gt2, 2] + Conjugate[Yd[3, 2]]*ZDR[gt2, 3]) + ZDL[gt1, 3]*(Conjugate[Yd[1, 3]]*ZDR[gt2, 1] + Conjugate[Yd[2, 3]]*ZDR[gt2, 2] + Conjugate[Yd[3, 3]]*ZDR[gt2, 3]))*((-I)*ZH[gt3, 1] + ZH[gt3, 3]) + (ZDL[gt1, 1]*(Conjugate[epsD[1, 1]]*ZDR[gt2, 1] + Conjugate[epsD[2, 1]]*ZDR[gt2, 2] + Conjugate[epsD[3, 1]]*ZDR[gt2, 3]) + ZDL[gt1, 2]*(Conjugate[epsD[1, 2]]*ZDR[gt2, 1] + Conjugate[epsD[2, 2]]*ZDR[gt2, 2] + Conjugate[epsD[3, 2]]*ZDR[gt2, 3]) + ZDL[gt1, 3]*(Conjugate[epsD[1, 3]]*ZDR[gt2, 1] + Conjugate[epsD[2, 3]]*ZDR[gt2, 2] + Conjugate[epsD[3, 3]]*ZDR[gt2, 3]))*((-I)*ZH[gt3, 2] + ZH[gt3, 4])))/Sqrt[2]}},
 C[-F[3, {gt1, ct1}], F[4, {gt2, ct2}], -S[3, {gt3}]] == {{(-I)*IndexDelta[ct1, ct2]*(E^(I*"eta")*(Conjugate[ZDL[gt2, 1]]*(Conjugate[ZUR[gt1, 1]]*epsU[1, 1] + Conjugate[ZUR[gt1, 2]]*epsU[2, 1] + Conjugate[ZUR[gt1, 3]]*epsU[3, 1]) + Conjugate[ZDL[gt2, 2]]*(Conjugate[ZUR[gt1, 1]]*epsU[1, 2] + Conjugate[ZUR[gt1, 2]]*epsU[2, 2] + Conjugate[ZUR[gt1, 3]]*epsU[3, 2]) + Conjugate[ZDL[gt2, 3]]*(Conjugate[ZUR[gt1, 1]]*epsU[1, 3] + Conjugate[ZUR[gt1, 2]]*epsU[2, 3] + Conjugate[ZUR[gt1, 3]]*epsU[3, 3]))*ZP[gt3, 1] + (Conjugate[ZDL[gt2, 1]]*(Conjugate[ZUR[gt1, 1]]*Yu[1, 1] + Conjugate[ZUR[gt1, 2]]*Yu[2, 1] + Conjugate[ZUR[gt1, 3]]*Yu[3, 1]) + Conjugate[ZDL[gt2, 2]]*(Conjugate[ZUR[gt1, 1]]*Yu[1, 2] + Conjugate[ZUR[gt1, 2]]*Yu[2, 2] + Conjugate[ZUR[gt1, 3]]*Yu[3, 2]) + Conjugate[ZDL[gt2, 3]]*(Conjugate[ZUR[gt1, 1]]*Yu[1, 3] + Conjugate[ZUR[gt1, 2]]*Yu[2, 3] + Conjugate[ZUR[gt1, 3]]*Yu[3, 3]))*ZP[gt3, 2])}, {(-I)*IndexDelta[ct1, ct2]*(ZP[gt3, 2]*((Conjugate[epsD[1, 1]]*ZDR[gt2, 1] + Conjugate[epsD[2, 1]]*ZDR[gt2, 2] + Conjugate[epsD[3, 1]]*ZDR[gt2, 3])*ZUL[gt1, 1] + (Conjugate[epsD[1, 2]]*ZDR[gt2, 1] + Conjugate[epsD[2, 2]]*ZDR[gt2, 2] + Conjugate[epsD[3, 2]]*ZDR[gt2, 3])*ZUL[gt1, 2] + (Conjugate[epsD[1, 3]]*ZDR[gt2, 1] + Conjugate[epsD[2, 3]]*ZDR[gt2, 2] + Conjugate[epsD[3, 3]]*ZDR[gt2, 3])*ZUL[gt1, 3]) + E^(I*"eta")*ZP[gt3, 1]*((Conjugate[Yd[1, 1]]*ZDR[gt2, 1] + Conjugate[Yd[2, 1]]*ZDR[gt2, 2] + Conjugate[Yd[3, 1]]*ZDR[gt2, 3])*ZUL[gt1, 1] + (Conjugate[Yd[1, 2]]*ZDR[gt2, 1] + Conjugate[Yd[2, 2]]*ZDR[gt2, 2] + Conjugate[Yd[3, 2]]*ZDR[gt2, 3])*ZUL[gt1, 2] + (Conjugate[Yd[1, 3]]*ZDR[gt2, 1] + Conjugate[Yd[2, 3]]*ZDR[gt2, 2] + Conjugate[Yd[3, 3]]*ZDR[gt2, 3])*ZUL[gt1, 3]))}},
 C[-F[2, {gt1}], F[2, {gt2}], S[1, {gt3}]] == {{((Conjugate[ZEL[gt2, 1]]*(Conjugate[ZER[gt1, 1]]*Ye[1, 1] + Conjugate[ZER[gt1, 2]]*Ye[2, 1] + Conjugate[ZER[gt1, 3]]*Ye[3, 1]) + Conjugate[ZEL[gt2, 2]]*(Conjugate[ZER[gt1, 1]]*Ye[1, 2] + Conjugate[ZER[gt1, 2]]*Ye[2, 2] + Conjugate[ZER[gt1, 3]]*Ye[3, 2]) + Conjugate[ZEL[gt2, 3]]*(Conjugate[ZER[gt1, 1]]*Ye[1, 3] + Conjugate[ZER[gt1, 2]]*Ye[2, 3] + Conjugate[ZER[gt1, 3]]*Ye[3, 3]))*((-I)*ZH[gt3, 1] - ZH[gt3, 3]) - I*E^(I*"eta")*(Conjugate[ZEL[gt2, 1]]*(Conjugate[ZER[gt1, 1]]*epsE[1, 1] + Conjugate[ZER[gt1, 2]]*epsE[2, 1] + Conjugate[ZER[gt1, 3]]*epsE[3, 1]) + Conjugate[ZEL[gt2, 2]]*(Conjugate[ZER[gt1, 1]]*epsE[1, 2] + Conjugate[ZER[gt1, 2]]*epsE[2, 2] + Conjugate[ZER[gt1, 3]]*epsE[3, 2]) + Conjugate[ZEL[gt2, 3]]*(Conjugate[ZER[gt1, 1]]*epsE[1, 3] + Conjugate[ZER[gt1, 2]]*epsE[2, 3] + Conjugate[ZER[gt1, 3]]*epsE[3, 3]))*(ZH[gt3, 2] - I*ZH[gt3, 4]))/(Sqrt[2]*E^(I*"eta"))}, {(E^(I*"eta")*(ZEL[gt1, 1]*(Conjugate[Ye[1, 1]]*ZER[gt2, 1] + Conjugate[Ye[2, 1]]*ZER[gt2, 2] + Conjugate[Ye[3, 1]]*ZER[gt2, 3]) + ZEL[gt1, 2]*(Conjugate[Ye[1, 2]]*ZER[gt2, 1] + Conjugate[Ye[2, 2]]*ZER[gt2, 2] + Conjugate[Ye[3, 2]]*ZER[gt2, 3]) + ZEL[gt1, 3]*(Conjugate[Ye[1, 3]]*ZER[gt2, 1] + Conjugate[Ye[2, 3]]*ZER[gt2, 2] + Conjugate[Ye[3, 3]]*ZER[gt2, 3]))*((-I)*ZH[gt3, 1] + ZH[gt3, 3]) + (ZEL[gt1, 1]*(Conjugate[epsE[1, 1]]*ZER[gt2, 1] + Conjugate[epsE[2, 1]]*ZER[gt2, 2] + Conjugate[epsE[3, 1]]*ZER[gt2, 3]) + ZEL[gt1, 2]*(Conjugate[epsE[1, 2]]*ZER[gt2, 1] + Conjugate[epsE[2, 2]]*ZER[gt2, 2] + Conjugate[epsE[3, 2]]*ZER[gt2, 3]) + ZEL[gt1, 3]*(Conjugate[epsE[1, 3]]*ZER[gt2, 1] + Conjugate[epsE[2, 3]]*ZER[gt2, 2] + Conjugate[epsE[3, 3]]*ZER[gt2, 3]))*((-I)*ZH[gt3, 2] + ZH[gt3, 4]))/Sqrt[2]}},
 C[-F[1, {gt1}], F[2, {gt2}], -S[3, {gt3}]] == {{0}, {(-I)*(E^(I*"eta")*(Conjugate[Ye[1, gt1]]*ZER[gt2, 1] + Conjugate[Ye[2, gt1]]*ZER[gt2, 2] + Conjugate[Ye[3, gt1]]*ZER[gt2, 3])*ZP[gt3, 1] + (Conjugate[epsE[1, gt1]]*ZER[gt2, 1] + Conjugate[epsE[2, gt1]]*ZER[gt2, 2] + Conjugate[epsE[3, gt1]]*ZER[gt2, 3])*ZP[gt3, 2])}},
 C[-F[3, {gt1, ct1}], F[3, {gt2, ct2}], S[1, {gt3}]] == {{(I*IndexDelta[ct1, ct2]*(E^(I*"eta")*(Conjugate[ZUL[gt2, 1]]*(Conjugate[ZUR[gt1, 1]]*epsU[1, 1] + Conjugate[ZUR[gt1, 2]]*epsU[2, 1] + Conjugate[ZUR[gt1, 3]]*epsU[3, 1]) + Conjugate[ZUL[gt2, 2]]*(Conjugate[ZUR[gt1, 1]]*epsU[1, 2] + Conjugate[ZUR[gt1, 2]]*epsU[2, 2] + Conjugate[ZUR[gt1, 3]]*epsU[3, 2]) + Conjugate[ZUL[gt2, 3]]*(Conjugate[ZUR[gt1, 1]]*epsU[1, 3] + Conjugate[ZUR[gt1, 2]]*epsU[2, 3] + Conjugate[ZUR[gt1, 3]]*epsU[3, 3]))*(ZH[gt3, 1] + I*ZH[gt3, 3]) + (Conjugate[ZUL[gt2, 1]]*(Conjugate[ZUR[gt1, 1]]*Yu[1, 1] + Conjugate[ZUR[gt1, 2]]*Yu[2, 1] + Conjugate[ZUR[gt1, 3]]*Yu[3, 1]) + Conjugate[ZUL[gt2, 2]]*(Conjugate[ZUR[gt1, 1]]*Yu[1, 2] + Conjugate[ZUR[gt1, 2]]*Yu[2, 2] + Conjugate[ZUR[gt1, 3]]*Yu[3, 2]) + Conjugate[ZUL[gt2, 3]]*(Conjugate[ZUR[gt1, 1]]*Yu[1, 3] + Conjugate[ZUR[gt1, 2]]*Yu[2, 3] + Conjugate[ZUR[gt1, 3]]*Yu[3, 3]))*(ZH[gt3, 2] + I*ZH[gt3, 4])))/Sqrt[2]}, {(IndexDelta[ct1, ct2]*((I*ZH[gt3, 1] + ZH[gt3, 3])*(ZUL[gt1, 1]*(Conjugate[epsU[1, 1]]*ZUR[gt2, 1] + Conjugate[epsU[2, 1]]*ZUR[gt2, 2] + Conjugate[epsU[3, 1]]*ZUR[gt2, 3]) + ZUL[gt1, 2]*(Conjugate[epsU[1, 2]]*ZUR[gt2, 1] + Conjugate[epsU[2, 2]]*ZUR[gt2, 2] + Conjugate[epsU[3, 2]]*ZUR[gt2, 3]) + ZUL[gt1, 3]*(Conjugate[epsU[1, 3]]*ZUR[gt2, 1] + Conjugate[epsU[2, 3]]*ZUR[gt2, 2] + Conjugate[epsU[3, 3]]*ZUR[gt2, 3])) + E^(I*"eta")*(I*ZH[gt3, 2] + ZH[gt3, 4])*(ZUL[gt1, 1]*(Conjugate[Yu[1, 1]]*ZUR[gt2, 1] + Conjugate[Yu[2, 1]]*ZUR[gt2, 2] + Conjugate[Yu[3, 1]]*ZUR[gt2, 3]) + ZUL[gt1, 2]*(Conjugate[Yu[1, 2]]*ZUR[gt2, 1] + Conjugate[Yu[2, 2]]*ZUR[gt2, 2] + Conjugate[Yu[3, 2]]*ZUR[gt2, 3]) + ZUL[gt1, 3]*(Conjugate[Yu[1, 3]]*ZUR[gt2, 1] + Conjugate[Yu[2, 3]]*ZUR[gt2, 2] + Conjugate[Yu[3, 3]]*ZUR[gt2, 3]))))/(Sqrt[2]*E^(I*"eta"))}},
 C[-F[4, {gt1, ct1}], F[3, {gt2, ct2}], S[3, {gt3}]] == {{(-I)*IndexDelta[ct1, ct2]*(Conjugate[ZP[gt3, 2]]*(Conjugate[ZUL[gt2, 1]]*(Conjugate[ZDR[gt1, 1]]*epsD[1, 1] + Conjugate[ZDR[gt1, 2]]*epsD[2, 1] + Conjugate[ZDR[gt1, 3]]*epsD[3, 1]) + Conjugate[ZUL[gt2, 2]]*(Conjugate[ZDR[gt1, 1]]*epsD[1, 2] + Conjugate[ZDR[gt1, 2]]*epsD[2, 2] + Conjugate[ZDR[gt1, 3]]*epsD[3, 2]) + Conjugate[ZUL[gt2, 3]]*(Conjugate[ZDR[gt1, 1]]*epsD[1, 3] + Conjugate[ZDR[gt1, 2]]*epsD[2, 3] + Conjugate[ZDR[gt1, 3]]*epsD[3, 3])) + (Conjugate[ZP[gt3, 1]]*(Conjugate[ZUL[gt2, 1]]*(Conjugate[ZDR[gt1, 1]]*Yd[1, 1] + Conjugate[ZDR[gt1, 2]]*Yd[2, 1] + Conjugate[ZDR[gt1, 3]]*Yd[3, 1]) + Conjugate[ZUL[gt2, 2]]*(Conjugate[ZDR[gt1, 1]]*Yd[1, 2] + Conjugate[ZDR[gt1, 2]]*Yd[2, 2] + Conjugate[ZDR[gt1, 3]]*Yd[3, 2]) + Conjugate[ZUL[gt2, 3]]*(Conjugate[ZDR[gt1, 1]]*Yd[1, 3] + Conjugate[ZDR[gt1, 2]]*Yd[2, 3] + Conjugate[ZDR[gt1, 3]]*Yd[3, 3])))/E^(I*"eta"))}, {(-I)*IndexDelta[ct1, ct2]*((Conjugate[ZP[gt3, 1]]*(ZDL[gt1, 1]*(Conjugate[epsU[1, 1]]*ZUR[gt2, 1] + Conjugate[epsU[2, 1]]*ZUR[gt2, 2] + Conjugate[epsU[3, 1]]*ZUR[gt2, 3]) + ZDL[gt1, 2]*(Conjugate[epsU[1, 2]]*ZUR[gt2, 1] + Conjugate[epsU[2, 2]]*ZUR[gt2, 2] + Conjugate[epsU[3, 2]]*ZUR[gt2, 3]) + ZDL[gt1, 3]*(Conjugate[epsU[1, 3]]*ZUR[gt2, 1] + Conjugate[epsU[2, 3]]*ZUR[gt2, 2] + Conjugate[epsU[3, 3]]*ZUR[gt2, 3])))/E^(I*"eta") + Conjugate[ZP[gt3, 2]]*(ZDL[gt1, 1]*(Conjugate[Yu[1, 1]]*ZUR[gt2, 1] + Conjugate[Yu[2, 1]]*ZUR[gt2, 2] + Conjugate[Yu[3, 1]]*ZUR[gt2, 3]) + ZDL[gt1, 2]*(Conjugate[Yu[1, 2]]*ZUR[gt2, 1] + Conjugate[Yu[2, 2]]*ZUR[gt2, 2] + Conjugate[Yu[3, 2]]*ZUR[gt2, 3]) + ZDL[gt1, 3]*(Conjugate[Yu[1, 3]]*ZUR[gt2, 1] + Conjugate[Yu[2, 3]]*ZUR[gt2, 2] + Conjugate[Yu[3, 3]]*ZUR[gt2, 3])))}},
 C[-F[2, {gt1}], F[1, {gt2}], S[3, {gt3}]] == {{(-I)*(Conjugate[ZP[gt3, 2]]*(Conjugate[ZER[gt1, 1]]*epsE[1, gt2] + Conjugate[ZER[gt1, 2]]*epsE[2, gt2] + Conjugate[ZER[gt1, 3]]*epsE[3, gt2]) + (Conjugate[ZP[gt3, 1]]*(Conjugate[ZER[gt1, 1]]*Ye[1, gt2] + Conjugate[ZER[gt1, 2]]*Ye[2, gt2] + Conjugate[ZER[gt1, 3]]*Ye[3, gt2]))/E^(I*"eta"))}, {0}},
 C[-F[4, {gt1, ct1}], F[4, {gt2, ct2}], V[5, {ct3}]] == {{(-I/2)*g3*IndexDelta[gt1, gt2]*Lam[ct3, ct1, ct2]}, {(-I/2)*g3*IndexDelta[gt1, gt2]*Lam[ct3, ct1, ct2]}},
 C[-F[4, {gt1, ct1}], F[4, {gt2, ct2}], V[1]] == {{(-I/6)*(CTW*g1 - 3*g2*STW)*IndexDelta[ct1, ct2]*IndexDelta[gt1, gt2]}, {(I/3)*CTW*g1*IndexDelta[ct1, ct2]*IndexDelta[gt1, gt2]}},
 C[-F[4, {gt1, ct1}], F[4, {gt2, ct2}], V[2]] == {{(I/6)*(3*CTW*g2 + g1*STW)*IndexDelta[ct1, ct2]*IndexDelta[gt1, gt2]}, {(-I/3)*g1*STW*IndexDelta[ct1, ct2]*IndexDelta[gt1, gt2]}},
 C[-F[3, {gt1, ct1}], F[4, {gt2, ct2}], -V[3]] == {{((-I)*g2*IndexDelta[ct1, ct2]*(Conjugate[ZDL[gt2, 1]]*ZUL[gt1, 1] + Conjugate[ZDL[gt2, 2]]*ZUL[gt1, 2] + Conjugate[ZDL[gt2, 3]]*ZUL[gt1, 3]))/Sqrt[2]}, {0}},
 C[-F[2, {gt1}], F[2, {gt2}], V[1]] == {{(I/2)*(CTW*g1 + g2*STW)*IndexDelta[gt1, gt2]}, {I*CTW*g1*IndexDelta[gt1, gt2]}},
 C[-F[2, {gt1}], F[2, {gt2}], V[2]] == {{(I/2)*(CTW*g2 - g1*STW)*IndexDelta[gt1, gt2]}, {(-I)*g1*STW*IndexDelta[gt1, gt2]}},
 C[-F[1, {gt1}], F[2, {gt2}], -V[3]] == {{((-I)*g2*Conjugate[ZEL[gt2, gt1]])/Sqrt[2]}, {0}},
 C[-F[3, {gt1, ct1}], F[3, {gt2, ct2}], V[5, {ct3}]] == {{(-I/2)*g3*IndexDelta[gt1, gt2]*Lam[ct3, ct1, ct2]}, {(-I/2)*g3*IndexDelta[gt1, gt2]*Lam[ct3, ct1, ct2]}},
 C[-F[3, {gt1, ct1}], F[3, {gt2, ct2}], V[1]] == {{(-I/6)*(CTW*g1 + 3*g2*STW)*IndexDelta[ct1, ct2]*IndexDelta[gt1, gt2]}, {((-2*I)/3)*CTW*g1*IndexDelta[ct1, ct2]*IndexDelta[gt1, gt2]}},
 C[-F[4, {gt1, ct1}], F[3, {gt2, ct2}], V[3]] == {{((-I)*g2*IndexDelta[ct1, ct2]*(Conjugate[ZUL[gt2, 1]]*ZDL[gt1, 1] + Conjugate[ZUL[gt2, 2]]*ZDL[gt1, 2] + Conjugate[ZUL[gt2, 3]]*ZDL[gt1, 3]))/Sqrt[2]}, {0}},
 C[-F[3, {gt1, ct1}], F[3, {gt2, ct2}], V[2]] == {{(-I/6)*(3*CTW*g2 - g1*STW)*IndexDelta[ct1, ct2]*IndexDelta[gt1, gt2]}, {((2*I)/3)*g1*STW*IndexDelta[ct1, ct2]*IndexDelta[gt1, gt2]}},
 C[-F[2, {gt1}], F[1, {gt2}], V[3]] == {{((-I)*g2*ZEL[gt1, gt2])/Sqrt[2]}, {0}},
 C[-F[1, {gt1}], F[1, {gt2}], V[2]] == {{(-I/2)*(CTW*g2 + g1*STW)*IndexDelta[gt1, gt2]}, {0}},
 C[S[1, {gt1}], S[1, {gt2}], S[1, {gt3}]] == {{(-(E^(I*"eta")*Lam6*vu*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 1]) + E^((3*I)*"eta")*vu*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 1] + 3*E^(I*"eta")*Lam6*vd*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 1] - E^((4*I)*"eta")*Lam5*vu*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 1] + vu*Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 1] - 3*E^((3*I)*"eta")*vd*Conjugate[Lam6]*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 1] - E^(I*"eta")*Lam6*vd*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 1] + E^((4*I)*"eta")*Lam5*vu*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 1] - vu*Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 1] + E^((3*I)*"eta")*vd*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 1] - E^((4*I)*"eta")*Lam5*vd*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 1] + E^(I*"eta")*Lam7*vu*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 1] + vd*Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 1] - E^((3*I)*"eta")*vu*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 1] - (4*I)*E^((2*I)*"eta")*Lam1*vd*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 1] - I*E^(I*"eta")*Lam6*vu*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 1] - I*E^((3*I)*"eta")*vu*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 1] - I*E^(I*"eta")*Lam6*vd*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 1] - I*E^((4*I)*"eta")*Lam5*vu*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 1] - I*vu*Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 1] - I*E^((3*I)*"eta")*vd*Conjugate[Lam6]*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 1] - I*E^(I*"eta")*Lam6*vd*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 1] - I*E^((4*I)*"eta")*Lam5*vu*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 1] - I*vu*Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 1] - I*E^((3*I)*"eta")*vd*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 1] - (2*I)*E^((2*I)*"eta")*Lam3*vd*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 1] - (2*I)*E^((2*I)*"eta")*Lam4*vd*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 1] + I*E^((4*I)*"eta")*Lam5*vd*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 1] - I*E^(I*"eta")*Lam7*vu*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 1] + I*vd*Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 1] - I*E^((3*I)*"eta")*vu*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 1] - E^(I*"eta")*Lam6*vd*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 2] + E^((4*I)*"eta")*Lam5*vu*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 2] - vu*Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 2] + E^((3*I)*"eta")*vd*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 2] - E^((4*I)*"eta")*Lam5*vd*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 2] + E^(I*"eta")*Lam7*vu*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 2] + vd*Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 2] - E^((3*I)*"eta")*vu*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 2] + E^((4*I)*"eta")*Lam5*vd*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 2] - 3*E^(I*"eta")*Lam7*vu*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 2] - vd*Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 2] + 3*E^((3*I)*"eta")*vu*Conjugate[Lam7]*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 2] + E^(I*"eta")*Lam7*vd*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 2] - E^((3*I)*"eta")*vd*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 2] - I*E^(I*"eta")*Lam6*vd*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 2] - (2*I)*E^((2*I)*"eta")*Lam3*vu*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 2] - (2*I)*E^((2*I)*"eta")*Lam4*vu*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 2] + I*E^((4*I)*"eta")*Lam5*vu*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 2] + I*vu*Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 2] - I*E^((3*I)*"eta")*vd*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 2] - I*E^((4*I)*"eta")*Lam5*vd*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 2] - I*E^(I*"eta")*Lam7*vu*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 2] - I*vd*Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 2] - I*E^((3*I)*"eta")*vu*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 2] - I*E^((4*I)*"eta")*Lam5*vd*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 2] - I*E^(I*"eta")*Lam7*vu*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 2] - I*vd*Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 2] - I*E^((3*I)*"eta")*vu*Conjugate[Lam7]*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 2] - I*E^(I*"eta")*Lam7*vd*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 2] - (4*I)*E^((2*I)*"eta")*Lam2*vu*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 2] - I*E^((3*I)*"eta")*vd*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 2] - (4*I)*E^((2*I)*"eta")*Lam1*vd*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 3] - I*E^(I*"eta")*Lam6*vu*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 3] - I*E^((3*I)*"eta")*vu*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 3] - I*E^(I*"eta")*Lam6*vd*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 3] - I*E^((4*I)*"eta")*Lam5*vu*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 3] - I*vu*Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 3] - I*E^((3*I)*"eta")*vd*Conjugate[Lam6]*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 3] - I*E^(I*"eta")*Lam6*vd*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 3] - (2*I)*E^((2*I)*"eta")*Lam3*vu*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 3] - (2*I)*E^((2*I)*"eta")*Lam4*vu*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 3] + I*E^((4*I)*"eta")*Lam5*vu*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 3] + I*vu*Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 3] - I*E^((3*I)*"eta")*vd*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 3] - I*E^((4*I)*"eta")*Lam5*vd*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 3] - I*E^(I*"eta")*Lam7*vu*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 3] - I*vd*Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 3] - I*E^((3*I)*"eta")*vu*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 3] - 3*E^(I*"eta")*Lam6*vu*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 3] + 3*E^((3*I)*"eta")*vu*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 3] + E^(I*"eta")*Lam6*vd*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 3] + E^((4*I)*"eta")*Lam5*vu*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 3] - vu*Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 3] - E^((3*I)*"eta")*vd*Conjugate[Lam6]*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 3] + E^(I*"eta")*Lam6*vd*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 3] + E^((4*I)*"eta")*Lam5*vu*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 3] - vu*Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 3] - E^((3*I)*"eta")*vd*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 3] - E^((4*I)*"eta")*Lam5*vd*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 3] - E^(I*"eta")*Lam7*vu*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 3] + vd*Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 3] + E^((3*I)*"eta")*vu*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 3] - I*E^(I*"eta")*Lam6*vd*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 4] - I*E^((4*I)*"eta")*Lam5*vu*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 4] - I*vu*Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 4] - I*E^((3*I)*"eta")*vd*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 4] - (2*I)*E^((2*I)*"eta")*Lam3*vd*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 4] - (2*I)*E^((2*I)*"eta")*Lam4*vd*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 4] + I*E^((4*I)*"eta")*Lam5*vd*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 4] - I*E^(I*"eta")*Lam7*vu*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 4] + I*vd*Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 4] - I*E^((3*I)*"eta")*vu*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 4] - I*E^((4*I)*"eta")*Lam5*vd*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 4] - I*E^(I*"eta")*Lam7*vu*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 4] - I*vd*Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 4] - I*E^((3*I)*"eta")*vu*Conjugate[Lam7]*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 4] - I*E^(I*"eta")*Lam7*vd*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 4] - (4*I)*E^((2*I)*"eta")*Lam2*vu*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 4] - I*E^((3*I)*"eta")*vd*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 4] + E^(I*"eta")*Lam6*vd*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 4] + E^((4*I)*"eta")*Lam5*vu*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 4] - vu*Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 4] - E^((3*I)*"eta")*vd*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 4] - E^((4*I)*"eta")*Lam5*vd*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 4] - E^(I*"eta")*Lam7*vu*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 4] + vd*Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 4] + E^((3*I)*"eta")*vu*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 4] - E^((4*I)*"eta")*Lam5*vd*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 4] - E^(I*"eta")*Lam7*vu*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 4] + vd*Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 4] + E^((3*I)*"eta")*vu*Conjugate[Lam7]*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 4] + 3*E^(I*"eta")*Lam7*vd*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 4] - 3*E^((3*I)*"eta")*vd*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 4] + ZH[gt1, 2]*(-(E^(I*"eta")*Lam6*vd*ZH[gt2, 3]*ZH[gt3, 1]) + E^((4*I)*"eta")*Lam5*vu*ZH[gt2, 3]*ZH[gt3, 1] - vu*Conjugate[Lam5]*ZH[gt2, 3]*ZH[gt3, 1] + E^((3*I)*"eta")*vd*Conjugate[Lam6]*ZH[gt2, 3]*ZH[gt3, 1] - E^((4*I)*"eta")*Lam5*vd*ZH[gt2, 4]*ZH[gt3, 1] + E^(I*"eta")*Lam7*vu*ZH[gt2, 4]*ZH[gt3, 1] + vd*Conjugate[Lam5]*ZH[gt2, 4]*ZH[gt3, 1] - E^((3*I)*"eta")*vu*Conjugate[Lam7]*ZH[gt2, 4]*ZH[gt3, 1] + E^((4*I)*"eta")*Lam5*vd*ZH[gt2, 3]*ZH[gt3, 2] - 3*E^(I*"eta")*Lam7*vu*ZH[gt2, 3]*ZH[gt3, 2] - vd*Conjugate[Lam5]*ZH[gt2, 3]*ZH[gt3, 2] + 3*E^((3*I)*"eta")*vu*Conjugate[Lam7]*ZH[gt2, 3]*ZH[gt3, 2] + E^(I*"eta")*Lam7*vd*ZH[gt2, 4]*ZH[gt3, 2] - E^((3*I)*"eta")*vd*Conjugate[Lam7]*ZH[gt2, 4]*ZH[gt3, 2] - I*E^(I*"eta")*Lam6*vd*ZH[gt2, 3]*ZH[gt3, 3] - (2*I)*E^((2*I)*"eta")*Lam3*vu*ZH[gt2, 3]*ZH[gt3, 3] - (2*I)*E^((2*I)*"eta")*Lam4*vu*ZH[gt2, 3]*ZH[gt3, 3] + I*E^((4*I)*"eta")*Lam5*vu*ZH[gt2, 3]*ZH[gt3, 3] + I*vu*Conjugate[Lam5]*ZH[gt2, 3]*ZH[gt3, 3] - I*E^((3*I)*"eta")*vd*Conjugate[Lam6]*ZH[gt2, 3]*ZH[gt3, 3] - I*E^((4*I)*"eta")*Lam5*vd*ZH[gt2, 4]*ZH[gt3, 3] - I*E^(I*"eta")*Lam7*vu*ZH[gt2, 4]*ZH[gt3, 3] - I*vd*Conjugate[Lam5]*ZH[gt2, 4]*ZH[gt3, 3] - I*E^((3*I)*"eta")*vu*Conjugate[Lam7]*ZH[gt2, 4]*ZH[gt3, 3] - I*E^((4*I)*"eta")*Lam5*vd*ZH[gt2, 3]*ZH[gt3, 4] - I*E^(I*"eta")*Lam7*vu*ZH[gt2, 3]*ZH[gt3, 4] - I*vd*Conjugate[Lam5]*ZH[gt2, 3]*ZH[gt3, 4] - I*E^((3*I)*"eta")*vu*Conjugate[Lam7]*ZH[gt2, 3]*ZH[gt3, 4] - I*E^(I*"eta")*Lam7*vd*ZH[gt2, 4]*ZH[gt3, 4] - (4*I)*E^((2*I)*"eta")*Lam2*vu*ZH[gt2, 4]*ZH[gt3, 4] - I*E^((3*I)*"eta")*vd*Conjugate[Lam7]*ZH[gt2, 4]*ZH[gt3, 4] + ZH[gt2, 2]*((-I)*(2*E^((2*I)*"eta")*Lam3*vd + 2*E^((2*I)*"eta")*Lam4*vd + E^((4*I)*"eta")*Lam5*vd + 3*E^(I*"eta")*Lam7*vu + vd*Conjugate[Lam5] + 3*E^((3*I)*"eta")*vu*Conjugate[Lam7])*ZH[gt3, 1] - (3*I)*E^(I*"eta")*(Lam7*vd + 4*E^(I*"eta")*Lam2*vu + E^((2*I)*"eta")*vd*Conjugate[Lam7])*ZH[gt3, 2] + E^((4*I)*"eta")*Lam5*vd*ZH[gt3, 3] - 3*E^(I*"eta")*Lam7*vu*ZH[gt3, 3] - vd*Conjugate[Lam5]*ZH[gt3, 3] + 3*E^((3*I)*"eta")*vu*Conjugate[Lam7]*ZH[gt3, 3] + E^(I*"eta")*Lam7*vd*ZH[gt3, 4] - E^((3*I)*"eta")*vd*Conjugate[Lam7]*ZH[gt3, 4]) + ZH[gt2, 1]*((-I)*(3*E^(I*"eta")*Lam6*vd + 2*E^((2*I)*"eta")*Lam3*vu + 2*E^((2*I)*"eta")*Lam4*vu + E^((4*I)*"eta")*Lam5*vu + vu*Conjugate[Lam5] + 3*E^((3*I)*"eta")*vd*Conjugate[Lam6])*ZH[gt3, 1] - I*(2*E^((2*I)*"eta")*Lam3*vd + 2*E^((2*I)*"eta")*Lam4*vd + E^((4*I)*"eta")*Lam5*vd + 3*E^(I*"eta")*Lam7*vu + vd*Conjugate[Lam5] + 3*E^((3*I)*"eta")*vu*Conjugate[Lam7])*ZH[gt3, 2] - E^(I*"eta")*Lam6*vd*ZH[gt3, 3] + E^((4*I)*"eta")*Lam5*vu*ZH[gt3, 3] - vu*Conjugate[Lam5]*ZH[gt3, 3] + E^((3*I)*"eta")*vd*Conjugate[Lam6]*ZH[gt3, 3] - E^((4*I)*"eta")*Lam5*vd*ZH[gt3, 4] + E^(I*"eta")*Lam7*vu*ZH[gt3, 4] + vd*Conjugate[Lam5]*ZH[gt3, 4] - E^((3*I)*"eta")*vu*Conjugate[Lam7]*ZH[gt3, 4])) + ZH[gt1, 1]*(-(E^(I*"eta")*Lam6*vu*ZH[gt2, 3]*ZH[gt3, 1]) + E^((3*I)*"eta")*vu*Conjugate[Lam6]*ZH[gt2, 3]*ZH[gt3, 1] + 3*E^(I*"eta")*Lam6*vd*ZH[gt2, 4]*ZH[gt3, 1] - E^((4*I)*"eta")*Lam5*vu*ZH[gt2, 4]*ZH[gt3, 1] + vu*Conjugate[Lam5]*ZH[gt2, 4]*ZH[gt3, 1] - 3*E^((3*I)*"eta")*vd*Conjugate[Lam6]*ZH[gt2, 4]*ZH[gt3, 1] - E^(I*"eta")*Lam6*vd*ZH[gt2, 3]*ZH[gt3, 2] + E^((4*I)*"eta")*Lam5*vu*ZH[gt2, 3]*ZH[gt3, 2] - vu*Conjugate[Lam5]*ZH[gt2, 3]*ZH[gt3, 2] + E^((3*I)*"eta")*vd*Conjugate[Lam6]*ZH[gt2, 3]*ZH[gt3, 2] - E^((4*I)*"eta")*Lam5*vd*ZH[gt2, 4]*ZH[gt3, 2] + E^(I*"eta")*Lam7*vu*ZH[gt2, 4]*ZH[gt3, 2] + vd*Conjugate[Lam5]*ZH[gt2, 4]*ZH[gt3, 2] - E^((3*I)*"eta")*vu*Conjugate[Lam7]*ZH[gt2, 4]*ZH[gt3, 2] - (4*I)*E^((2*I)*"eta")*Lam1*vd*ZH[gt2, 3]*ZH[gt3, 3] - I*E^(I*"eta")*Lam6*vu*ZH[gt2, 3]*ZH[gt3, 3] - I*E^((3*I)*"eta")*vu*Conjugate[Lam6]*ZH[gt2, 3]*ZH[gt3, 3] - I*E^(I*"eta")*Lam6*vd*ZH[gt2, 4]*ZH[gt3, 3] - I*E^((4*I)*"eta")*Lam5*vu*ZH[gt2, 4]*ZH[gt3, 3] - I*vu*Conjugate[Lam5]*ZH[gt2, 4]*ZH[gt3, 3] - I*E^((3*I)*"eta")*vd*Conjugate[Lam6]*ZH[gt2, 4]*ZH[gt3, 3] - I*E^(I*"eta")*Lam6*vd*ZH[gt2, 3]*ZH[gt3, 4] - I*E^((4*I)*"eta")*Lam5*vu*ZH[gt2, 3]*ZH[gt3, 4] - I*vu*Conjugate[Lam5]*ZH[gt2, 3]*ZH[gt3, 4] - I*E^((3*I)*"eta")*vd*Conjugate[Lam6]*ZH[gt2, 3]*ZH[gt3, 4] - (2*I)*E^((2*I)*"eta")*Lam3*vd*ZH[gt2, 4]*ZH[gt3, 4] - (2*I)*E^((2*I)*"eta")*Lam4*vd*ZH[gt2, 4]*ZH[gt3, 4] + I*E^((4*I)*"eta")*Lam5*vd*ZH[gt2, 4]*ZH[gt3, 4] - I*E^(I*"eta")*Lam7*vu*ZH[gt2, 4]*ZH[gt3, 4] + I*vd*Conjugate[Lam5]*ZH[gt2, 4]*ZH[gt3, 4] - I*E^((3*I)*"eta")*vu*Conjugate[Lam7]*ZH[gt2, 4]*ZH[gt3, 4] + ZH[gt2, 1]*((-3*I)*E^(I*"eta")*(4*E^(I*"eta")*Lam1*vd + Lam6*vu + E^((2*I)*"eta")*vu*Conjugate[Lam6])*ZH[gt3, 1] - I*(3*E^(I*"eta")*Lam6*vd + 2*E^((2*I)*"eta")*Lam3*vu + 2*E^((2*I)*"eta")*Lam4*vu + E^((4*I)*"eta")*Lam5*vu + vu*Conjugate[Lam5] + 3*E^((3*I)*"eta")*vd*Conjugate[Lam6])*ZH[gt3, 2] - E^(I*"eta")*Lam6*vu*ZH[gt3, 3] + E^((3*I)*"eta")*vu*Conjugate[Lam6]*ZH[gt3, 3] + 3*E^(I*"eta")*Lam6*vd*ZH[gt3, 4] - E^((4*I)*"eta")*Lam5*vu*ZH[gt3, 4] + vu*Conjugate[Lam5]*ZH[gt3, 4] - 3*E^((3*I)*"eta")*vd*Conjugate[Lam6]*ZH[gt3, 4]) + ZH[gt2, 2]*((-I)*(3*E^(I*"eta")*Lam6*vd + 2*E^((2*I)*"eta")*Lam3*vu + 2*E^((2*I)*"eta")*Lam4*vu + E^((4*I)*"eta")*Lam5*vu + vu*Conjugate[Lam5] + 3*E^((3*I)*"eta")*vd*Conjugate[Lam6])*ZH[gt3, 1] - I*(2*E^((2*I)*"eta")*Lam3*vd + 2*E^((2*I)*"eta")*Lam4*vd + E^((4*I)*"eta")*Lam5*vd + 3*E^(I*"eta")*Lam7*vu + vd*Conjugate[Lam5] + 3*E^((3*I)*"eta")*vu*Conjugate[Lam7])*ZH[gt3, 2] - E^(I*"eta")*Lam6*vd*ZH[gt3, 3] + E^((4*I)*"eta")*Lam5*vu*ZH[gt3, 3] - vu*Conjugate[Lam5]*ZH[gt3, 3] + E^((3*I)*"eta")*vd*Conjugate[Lam6]*ZH[gt3, 3] - E^((4*I)*"eta")*Lam5*vd*ZH[gt3, 4] + E^(I*"eta")*Lam7*vu*ZH[gt3, 4] + vd*Conjugate[Lam5]*ZH[gt3, 4] - E^((3*I)*"eta")*vu*Conjugate[Lam7]*ZH[gt3, 4])))/(2*E^((2*I)*"eta"))}},
 C[S[1, {gt1}], S[3, {gt2}], -S[3, {gt3}]] == {{(Conjugate[ZP[gt2, 1]]*((vu*ZH[gt1, 3] - vd*ZH[gt1, 4])*(E^(I*"eta")*(-Lam6 + E^((2*I)*"eta")*Conjugate[Lam6])*ZP[gt3, 1] + (E^((2*I)*"eta")*Lam4 - Conjugate[Lam5])*ZP[gt3, 2]) - I*ZH[gt1, 2]*(E^(I*"eta")*(Lam6*vd + 2*E^(I*"eta")*Lam3*vu + E^((2*I)*"eta")*vd*Conjugate[Lam6])*ZP[gt3, 1] + (E^((2*I)*"eta")*Lam4*vd + 2*E^(I*"eta")*Lam7*vu + vd*Conjugate[Lam5])*ZP[gt3, 2]) - I*ZH[gt1, 1]*(E^(I*"eta")*(4*E^(I*"eta")*Lam1*vd + Lam6*vu + E^((2*I)*"eta")*vu*Conjugate[Lam6])*ZP[gt3, 1] + (2*E^(I*"eta")*Lam6*vd + E^((2*I)*"eta")*Lam4*vu + vu*Conjugate[Lam5])*ZP[gt3, 2])) + E^(I*"eta")*Conjugate[ZP[gt2, 2]]*((vu*ZH[gt1, 3] - vd*ZH[gt1, 4])*(E^(I*"eta")*(-Lam4 + E^((2*I)*"eta")*Lam5)*ZP[gt3, 1] - (Lam7 - E^((2*I)*"eta")*Conjugate[Lam7])*ZP[gt3, 2]) - I*ZH[gt1, 2]*(E^(I*"eta")*(Lam4*vd + E^((2*I)*"eta")*Lam5*vd + 2*E^(I*"eta")*vu*Conjugate[Lam7])*ZP[gt3, 1] + (Lam7*vd + 4*E^(I*"eta")*Lam2*vu + E^((2*I)*"eta")*vd*Conjugate[Lam7])*ZP[gt3, 2]) - I*ZH[gt1, 1]*(E^(I*"eta")*(Lam4*vu + E^((2*I)*"eta")*Lam5*vu + 2*E^(I*"eta")*vd*Conjugate[Lam6])*ZP[gt3, 1] + (2*E^(I*"eta")*Lam3*vd + Lam7*vu + E^((2*I)*"eta")*vu*Conjugate[Lam7])*ZP[gt3, 2])))/(2*E^((2*I)*"eta"))}},
 C[S[1, {gt1}], S[1, {gt2}], V[2]] == {{-((CTW*g2 + g1*STW)*(ZH[gt1, 3]*ZH[gt2, 1] + ZH[gt1, 4]*ZH[gt2, 2] - ZH[gt1, 1]*ZH[gt2, 3] - ZH[gt1, 2]*ZH[gt2, 4]))/2}},
 C[S[1, {gt1}], S[3, {gt2}], -V[3]] == {{(g2*(Conjugate[ZP[gt2, 1]]*((-I)*ZH[gt1, 1] + ZH[gt1, 3]) + Conjugate[ZP[gt2, 2]]*((-I)*ZH[gt1, 2] + ZH[gt1, 4])))/2}},
 C[S[1, {gt1}], -S[3, {gt2}], V[3]] == {{(g2*(I*ZH[gt1, 1]*ZP[gt2, 1] + ZH[gt1, 3]*ZP[gt2, 1] + (I*ZH[gt1, 2] + ZH[gt1, 4])*ZP[gt2, 2]))/2}},
 C[S[3, {gt1}], -S[3, {gt2}], V[1]] == {{(I/2)*(CTW*g1 + g2*STW)*(Conjugate[ZP[gt1, 1]]*ZP[gt2, 1] + Conjugate[ZP[gt1, 2]]*ZP[gt2, 2])}},
 C[S[3, {gt1}], -S[3, {gt2}], V[2]] == {{(I/2)*(CTW*g2 - g1*STW)*(Conjugate[ZP[gt1, 1]]*ZP[gt2, 1] + Conjugate[ZP[gt1, 2]]*ZP[gt2, 2])}},
 C[S[1, {gt1}], -V[3], V[3]] == {{(I/2)*g2^2*(vd*ZH[gt1, 1] + vu*ZH[gt1, 2])}},
 C[S[1, {gt1}], V[2], V[2]] == {{(I/2)*(CTW*g2 + g1*STW)^2*(vd*ZH[gt1, 1] + vu*ZH[gt1, 2])}},
 C[S[3, {gt1}], -V[3], V[1]] == {{(I/2)*CTW*g1*g2*(vd*Conjugate[ZP[gt1, 1]] + vu*Conjugate[ZP[gt1, 2]])}},
 C[S[3, {gt1}], -V[3], V[2]] == {{(-I/2)*g1*g2*STW*(vd*Conjugate[ZP[gt1, 1]] + vu*Conjugate[ZP[gt1, 2]])}},
 C[-S[3, {gt1}], V[1], V[3]] == {{(I/2)*CTW*g1*g2*(vd*ZP[gt1, 1] + vu*ZP[gt1, 2])}},
 C[-S[3, {gt1}], V[3], V[2]] == {{(-I/2)*g1*g2*STW*(vd*ZP[gt1, 1] + vu*ZP[gt1, 2])}},
 C[S[1, {gt1}], S[1, {gt2}], S[1, {gt3}], S[1, {gt4}]] == {{(3*E^(I*"eta")*Lam6*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 1]*ZH[gt4, 1] - 3*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 1]*ZH[gt4, 1] - E^(I*"eta")*Lam6*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 1]*ZH[gt4, 1] + E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 1]*ZH[gt4, 1] - E^((4*I)*"eta")*Lam5*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 1]*ZH[gt4, 1] + Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 1]*ZH[gt4, 1] - (4*I)*E^((2*I)*"eta")*Lam1*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 1]*ZH[gt4, 1] - I*E^(I*"eta")*Lam6*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 1]*ZH[gt4, 1] - I*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 1]*ZH[gt4, 1] - I*E^(I*"eta")*Lam6*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 1] - I*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 1] - (2*I)*E^((2*I)*"eta")*Lam3*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 1] - (2*I)*E^((2*I)*"eta")*Lam4*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 1] + I*E^((4*I)*"eta")*Lam5*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 1] + I*Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 1] - E^(I*"eta")*Lam6*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 2]*ZH[gt4, 1] + E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 2]*ZH[gt4, 1] - E^((4*I)*"eta")*Lam5*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 2]*ZH[gt4, 1] + Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 2]*ZH[gt4, 1] + E^((4*I)*"eta")*Lam5*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 2]*ZH[gt4, 1] - Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 2]*ZH[gt4, 1] + E^(I*"eta")*Lam7*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 2]*ZH[gt4, 1] - E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 2]*ZH[gt4, 1] - I*E^(I*"eta")*Lam6*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 1] - I*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 1] - I*E^((4*I)*"eta")*Lam5*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 1] - I*Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 1] - I*E^((4*I)*"eta")*Lam5*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 2]*ZH[gt4, 1] - I*Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 2]*ZH[gt4, 1] - I*E^(I*"eta")*Lam7*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 2]*ZH[gt4, 1] - I*E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 2]*ZH[gt4, 1] - (4*I)*E^((2*I)*"eta")*Lam1*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 3]*ZH[gt4, 1] - I*E^(I*"eta")*Lam6*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 3]*ZH[gt4, 1] - I*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 3]*ZH[gt4, 1] - I*E^(I*"eta")*Lam6*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 3]*ZH[gt4, 1] - I*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 3]*ZH[gt4, 1] - I*E^((4*I)*"eta")*Lam5*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 3]*ZH[gt4, 1] - I*Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 3]*ZH[gt4, 1] + E^(I*"eta")*Lam6*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 3]*ZH[gt4, 1] - E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 3]*ZH[gt4, 1] + E^(I*"eta")*Lam6*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 1] - E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 1] - E^((4*I)*"eta")*Lam5*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 1] + Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 1] - I*E^(I*"eta")*Lam6*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 4]*ZH[gt4, 1] - I*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 4]*ZH[gt4, 1] - (2*I)*E^((2*I)*"eta")*Lam3*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 4]*ZH[gt4, 1] - (2*I)*E^((2*I)*"eta")*Lam4*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 4]*ZH[gt4, 1] + I*E^((4*I)*"eta")*Lam5*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 4]*ZH[gt4, 1] + I*Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 4]*ZH[gt4, 1] - I*E^((4*I)*"eta")*Lam5*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 4]*ZH[gt4, 1] - I*Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 4]*ZH[gt4, 1] - I*E^(I*"eta")*Lam7*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 4]*ZH[gt4, 1] - I*E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 4]*ZH[gt4, 1] + E^(I*"eta")*Lam6*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 1] - E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 1] - E^((4*I)*"eta")*Lam5*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 1] + Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 1] - E^((4*I)*"eta")*Lam5*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 4]*ZH[gt4, 1] + Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 4]*ZH[gt4, 1] + 3*E^(I*"eta")*Lam7*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 4]*ZH[gt4, 1] - 3*E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 4]*ZH[gt4, 1] - E^(I*"eta")*Lam6*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 1]*ZH[gt4, 2] + E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 1]*ZH[gt4, 2] - E^((4*I)*"eta")*Lam5*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 1]*ZH[gt4, 2] + Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 1]*ZH[gt4, 2] + E^((4*I)*"eta")*Lam5*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 1]*ZH[gt4, 2] - Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 1]*ZH[gt4, 2] + E^(I*"eta")*Lam7*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 1]*ZH[gt4, 2] - E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 1]*ZH[gt4, 2] - I*E^(I*"eta")*Lam6*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 1]*ZH[gt4, 2] - I*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 1]*ZH[gt4, 2] - I*E^((4*I)*"eta")*Lam5*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 1]*ZH[gt4, 2] - I*Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 1]*ZH[gt4, 2] - I*E^((4*I)*"eta")*Lam5*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 2] - I*Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 2] - I*E^(I*"eta")*Lam7*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 2] - I*E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 2] + E^((4*I)*"eta")*Lam5*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 2]*ZH[gt4, 2] - Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 2]*ZH[gt4, 2] + E^(I*"eta")*Lam7*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 2]*ZH[gt4, 2] - E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 2]*ZH[gt4, 2] - 3*E^(I*"eta")*Lam7*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 2]*ZH[gt4, 2] + 3*E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 2]*ZH[gt4, 2] - (2*I)*E^((2*I)*"eta")*Lam3*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 2] - (2*I)*E^((2*I)*"eta")*Lam4*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 2] + I*E^((4*I)*"eta")*Lam5*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 2] + I*Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 2] - I*E^(I*"eta")*Lam7*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 2] - I*E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 2] - I*E^(I*"eta")*Lam7*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 2]*ZH[gt4, 2] - I*E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 2]*ZH[gt4, 2] - (4*I)*E^((2*I)*"eta")*Lam2*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 2]*ZH[gt4, 2] - I*E^(I*"eta")*Lam6*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 3]*ZH[gt4, 2] - I*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 3]*ZH[gt4, 2] - I*E^((4*I)*"eta")*Lam5*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 3]*ZH[gt4, 2] - I*Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 3]*ZH[gt4, 2] - (2*I)*E^((2*I)*"eta")*Lam3*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 3]*ZH[gt4, 2] - (2*I)*E^((2*I)*"eta")*Lam4*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 3]*ZH[gt4, 2] + I*E^((4*I)*"eta")*Lam5*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 3]*ZH[gt4, 2] + I*Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 3]*ZH[gt4, 2] - I*E^(I*"eta")*Lam7*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 3]*ZH[gt4, 2] - I*E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 3]*ZH[gt4, 2] - 3*E^(I*"eta")*Lam6*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 3]*ZH[gt4, 2] + 3*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 3]*ZH[gt4, 2] + E^((4*I)*"eta")*Lam5*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 3]*ZH[gt4, 2] - Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 3]*ZH[gt4, 2] + E^((4*I)*"eta")*Lam5*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 2] - Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 2] - E^(I*"eta")*Lam7*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 2] + E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 2] - I*E^((4*I)*"eta")*Lam5*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 4]*ZH[gt4, 2] - I*Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 4]*ZH[gt4, 2] - I*E^(I*"eta")*Lam7*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 4]*ZH[gt4, 2] - I*E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 4]*ZH[gt4, 2] - I*E^(I*"eta")*Lam7*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 4]*ZH[gt4, 2] - I*E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 4]*ZH[gt4, 2] - (4*I)*E^((2*I)*"eta")*Lam2*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 4]*ZH[gt4, 2] + E^((4*I)*"eta")*Lam5*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 2] - Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 2] - E^(I*"eta")*Lam7*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 2] + E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 2] - E^(I*"eta")*Lam7*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 4]*ZH[gt4, 2] + E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 4]*ZH[gt4, 2] - (4*I)*E^((2*I)*"eta")*Lam1*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 1]*ZH[gt4, 3] - I*E^(I*"eta")*Lam6*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 1]*ZH[gt4, 3] - I*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 1]*ZH[gt4, 3] - I*E^(I*"eta")*Lam6*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 1]*ZH[gt4, 3] - I*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 1]*ZH[gt4, 3] - I*E^((4*I)*"eta")*Lam5*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 1]*ZH[gt4, 3] - I*Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 1]*ZH[gt4, 3] + E^(I*"eta")*Lam6*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 1]*ZH[gt4, 3] - E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 1]*ZH[gt4, 3] + E^(I*"eta")*Lam6*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 3] - E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 3] - E^((4*I)*"eta")*Lam5*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 3] + Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 3] - I*E^(I*"eta")*Lam6*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 2]*ZH[gt4, 3] - I*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 2]*ZH[gt4, 3] - I*E^((4*I)*"eta")*Lam5*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 2]*ZH[gt4, 3] - I*Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 2]*ZH[gt4, 3] - (2*I)*E^((2*I)*"eta")*Lam3*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 2]*ZH[gt4, 3] - (2*I)*E^((2*I)*"eta")*Lam4*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 2]*ZH[gt4, 3] + I*E^((4*I)*"eta")*Lam5*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 2]*ZH[gt4, 3] + I*Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 2]*ZH[gt4, 3] - I*E^(I*"eta")*Lam7*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 2]*ZH[gt4, 3] - I*E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 2]*ZH[gt4, 3] - 3*E^(I*"eta")*Lam6*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 3] + 3*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 3] + E^((4*I)*"eta")*Lam5*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 3] - Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 3] + E^((4*I)*"eta")*Lam5*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 2]*ZH[gt4, 3] - Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 2]*ZH[gt4, 3] - E^(I*"eta")*Lam7*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 2]*ZH[gt4, 3] + E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 2]*ZH[gt4, 3] + E^(I*"eta")*Lam6*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 3]*ZH[gt4, 3] - E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 3]*ZH[gt4, 3] - 3*E^(I*"eta")*Lam6*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 3]*ZH[gt4, 3] + 3*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 3]*ZH[gt4, 3] + E^((4*I)*"eta")*Lam5*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 3]*ZH[gt4, 3] - Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 3]*ZH[gt4, 3] - (12*I)*E^((2*I)*"eta")*Lam1*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 3]*ZH[gt4, 3] - (3*I)*E^(I*"eta")*Lam6*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 3]*ZH[gt4, 3] - (3*I)*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 3]*ZH[gt4, 3] - (3*I)*E^(I*"eta")*Lam6*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 3] - (3*I)*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 3] - (2*I)*E^((2*I)*"eta")*Lam3*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 3] - (2*I)*E^((2*I)*"eta")*Lam4*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 3] - I*E^((4*I)*"eta")*Lam5*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 3] - I*Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 3] + E^(I*"eta")*Lam6*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 4]*ZH[gt4, 3] - E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 4]*ZH[gt4, 3] - E^((4*I)*"eta")*Lam5*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 4]*ZH[gt4, 3] + Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 4]*ZH[gt4, 3] + E^((4*I)*"eta")*Lam5*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 4]*ZH[gt4, 3] - Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 4]*ZH[gt4, 3] - E^(I*"eta")*Lam7*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 4]*ZH[gt4, 3] + E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 4]*ZH[gt4, 3] - (3*I)*E^(I*"eta")*Lam6*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 3] - (3*I)*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 3] - (2*I)*E^((2*I)*"eta")*Lam3*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 3] - (2*I)*E^((2*I)*"eta")*Lam4*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 3] - I*E^((4*I)*"eta")*Lam5*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 3] - I*Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 3] - (2*I)*E^((2*I)*"eta")*Lam3*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 4]*ZH[gt4, 3] - (2*I)*E^((2*I)*"eta")*Lam4*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 4]*ZH[gt4, 3] - I*E^((4*I)*"eta")*Lam5*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 4]*ZH[gt4, 3] - I*Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 4]*ZH[gt4, 3] - (3*I)*E^(I*"eta")*Lam7*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 4]*ZH[gt4, 3] - (3*I)*E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 4]*ZH[gt4, 3] - I*E^(I*"eta")*Lam6*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 1]*ZH[gt4, 4] - I*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 1]*ZH[gt4, 4] - (2*I)*E^((2*I)*"eta")*Lam3*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 1]*ZH[gt4, 4] - (2*I)*E^((2*I)*"eta")*Lam4*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 1]*ZH[gt4, 4] + I*E^((4*I)*"eta")*Lam5*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 1]*ZH[gt4, 4] + I*Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 1]*ZH[gt4, 4] - I*E^((4*I)*"eta")*Lam5*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 1]*ZH[gt4, 4] - I*Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 1]*ZH[gt4, 4] - I*E^(I*"eta")*Lam7*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 1]*ZH[gt4, 4] - I*E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 1]*ZH[gt4, 4] + E^(I*"eta")*Lam6*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 1]*ZH[gt4, 4] - E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 1]*ZH[gt4, 4] - E^((4*I)*"eta")*Lam5*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 1]*ZH[gt4, 4] + Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 1]*ZH[gt4, 4] - E^((4*I)*"eta")*Lam5*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 4] + Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 4] + 3*E^(I*"eta")*Lam7*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 4] - 3*E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 4] - I*E^((4*I)*"eta")*Lam5*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 2]*ZH[gt4, 4] - I*Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 2]*ZH[gt4, 4] - I*E^(I*"eta")*Lam7*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 2]*ZH[gt4, 4] - I*E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 2]*ZH[gt4, 4] - I*E^(I*"eta")*Lam7*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 2]*ZH[gt4, 4] - I*E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 2]*ZH[gt4, 4] - (4*I)*E^((2*I)*"eta")*Lam2*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 2]*ZH[gt4, 4] + E^((4*I)*"eta")*Lam5*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 4] - Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 4] - E^(I*"eta")*Lam7*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 4] + E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 4] - E^(I*"eta")*Lam7*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 2]*ZH[gt4, 4] + E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 2]*ZH[gt4, 4] + E^(I*"eta")*Lam6*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 3]*ZH[gt4, 4] - E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 3]*ZH[gt4, 4] - E^((4*I)*"eta")*Lam5*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 3]*ZH[gt4, 4] + Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 3]*ZH[gt4, 4] + E^((4*I)*"eta")*Lam5*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 3]*ZH[gt4, 4] - Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 3]*ZH[gt4, 4] - E^(I*"eta")*Lam7*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 3]*ZH[gt4, 4] + E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 2]*ZH[gt3, 3]*ZH[gt4, 4] - (3*I)*E^(I*"eta")*Lam6*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 3]*ZH[gt4, 4] - (3*I)*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 3]*ZH[gt4, 4] - (2*I)*E^((2*I)*"eta")*Lam3*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 3]*ZH[gt4, 4] - (2*I)*E^((2*I)*"eta")*Lam4*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 3]*ZH[gt4, 4] - I*E^((4*I)*"eta")*Lam5*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 3]*ZH[gt4, 4] - I*Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 3]*ZH[gt4, 4] - (2*I)*E^((2*I)*"eta")*Lam3*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 4] - (2*I)*E^((2*I)*"eta")*Lam4*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 4] - I*E^((4*I)*"eta")*Lam5*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 4] - I*Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 4] - (3*I)*E^(I*"eta")*Lam7*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 4] - (3*I)*E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 4] - E^((4*I)*"eta")*Lam5*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 4]*ZH[gt4, 4] + Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 1]*ZH[gt3, 4]*ZH[gt4, 4] + 3*E^(I*"eta")*Lam7*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 4]*ZH[gt4, 4] - 3*E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 1]*ZH[gt3, 4]*ZH[gt4, 4] - E^(I*"eta")*Lam7*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 4]*ZH[gt4, 4] + E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 3]*ZH[gt2, 2]*ZH[gt3, 4]*ZH[gt4, 4] - (2*I)*E^((2*I)*"eta")*Lam3*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 4] - (2*I)*E^((2*I)*"eta")*Lam4*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 4] - I*E^((4*I)*"eta")*Lam5*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 4] - I*Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 4] - (3*I)*E^(I*"eta")*Lam7*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 4] - (3*I)*E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 4] - (3*I)*E^(I*"eta")*Lam7*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 4]*ZH[gt4, 4] - (3*I)*E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 3]*ZH[gt2, 4]*ZH[gt3, 4]*ZH[gt4, 4] - (12*I)*E^((2*I)*"eta")*Lam2*ZH[gt1, 4]*ZH[gt2, 4]*ZH[gt3, 4]*ZH[gt4, 4] + ZH[gt1, 2]*(-(E^(I*"eta")*Lam6*ZH[gt2, 3]*ZH[gt3, 1]*ZH[gt4, 1]) + E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt2, 3]*ZH[gt3, 1]*ZH[gt4, 1] - E^((4*I)*"eta")*Lam5*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 1] + Conjugate[Lam5]*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 1] + E^((4*I)*"eta")*Lam5*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 1] - Conjugate[Lam5]*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 1] + E^(I*"eta")*Lam7*ZH[gt2, 4]*ZH[gt3, 2]*ZH[gt4, 1] - E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt2, 4]*ZH[gt3, 2]*ZH[gt4, 1] - I*E^(I*"eta")*Lam6*ZH[gt2, 3]*ZH[gt3, 3]*ZH[gt4, 1] - I*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt2, 3]*ZH[gt3, 3]*ZH[gt4, 1] - I*E^((4*I)*"eta")*Lam5*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 1] - I*Conjugate[Lam5]*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 1] - I*E^((4*I)*"eta")*Lam5*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 1] - I*Conjugate[Lam5]*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 1] - I*E^(I*"eta")*Lam7*ZH[gt2, 4]*ZH[gt3, 4]*ZH[gt4, 1] - I*E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt2, 4]*ZH[gt3, 4]*ZH[gt4, 1] + E^((4*I)*"eta")*Lam5*ZH[gt2, 3]*ZH[gt3, 1]*ZH[gt4, 2] - Conjugate[Lam5]*ZH[gt2, 3]*ZH[gt3, 1]*ZH[gt4, 2] + E^(I*"eta")*Lam7*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 2] - E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 2] - 3*E^(I*"eta")*Lam7*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 2] + 3*E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 2] - (2*I)*E^((2*I)*"eta")*Lam3*ZH[gt2, 3]*ZH[gt3, 3]*ZH[gt4, 2] - (2*I)*E^((2*I)*"eta")*Lam4*ZH[gt2, 3]*ZH[gt3, 3]*ZH[gt4, 2] + I*E^((4*I)*"eta")*Lam5*ZH[gt2, 3]*ZH[gt3, 3]*ZH[gt4, 2] + I*Conjugate[Lam5]*ZH[gt2, 3]*ZH[gt3, 3]*ZH[gt4, 2] - I*E^(I*"eta")*Lam7*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 2] - I*E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 2] - I*E^(I*"eta")*Lam7*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 2] - I*E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 2] - (4*I)*E^((2*I)*"eta")*Lam2*ZH[gt2, 4]*ZH[gt3, 4]*ZH[gt4, 2] - I*E^(I*"eta")*Lam6*ZH[gt2, 3]*ZH[gt3, 1]*ZH[gt4, 3] - I*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt2, 3]*ZH[gt3, 1]*ZH[gt4, 3] - I*E^((4*I)*"eta")*Lam5*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 3] - I*Conjugate[Lam5]*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 3] - (2*I)*E^((2*I)*"eta")*Lam3*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 3] - (2*I)*E^((2*I)*"eta")*Lam4*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 3] + I*E^((4*I)*"eta")*Lam5*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 3] + I*Conjugate[Lam5]*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 3] - I*E^(I*"eta")*Lam7*ZH[gt2, 4]*ZH[gt3, 2]*ZH[gt4, 3] - I*E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt2, 4]*ZH[gt3, 2]*ZH[gt4, 3] - 3*E^(I*"eta")*Lam6*ZH[gt2, 3]*ZH[gt3, 3]*ZH[gt4, 3] + 3*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt2, 3]*ZH[gt3, 3]*ZH[gt4, 3] + E^((4*I)*"eta")*Lam5*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 3] - Conjugate[Lam5]*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 3] + E^((4*I)*"eta")*Lam5*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 3] - Conjugate[Lam5]*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 3] - E^(I*"eta")*Lam7*ZH[gt2, 4]*ZH[gt3, 4]*ZH[gt4, 3] + E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt2, 4]*ZH[gt3, 4]*ZH[gt4, 3] - I*E^((4*I)*"eta")*Lam5*ZH[gt2, 3]*ZH[gt3, 1]*ZH[gt4, 4] - I*Conjugate[Lam5]*ZH[gt2, 3]*ZH[gt3, 1]*ZH[gt4, 4] - I*E^(I*"eta")*Lam7*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 4] - I*E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 4] - I*E^(I*"eta")*Lam7*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 4] - I*E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 4] - (4*I)*E^((2*I)*"eta")*Lam2*ZH[gt2, 4]*ZH[gt3, 2]*ZH[gt4, 4] + E^((4*I)*"eta")*Lam5*ZH[gt2, 3]*ZH[gt3, 3]*ZH[gt4, 4] - Conjugate[Lam5]*ZH[gt2, 3]*ZH[gt3, 3]*ZH[gt4, 4] - E^(I*"eta")*Lam7*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 4] + E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 4] - E^(I*"eta")*Lam7*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 4] + E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 4] + ZH[gt2, 2]*(E^((4*I)*"eta")*Lam5*ZH[gt3, 3]*ZH[gt4, 1] - Conjugate[Lam5]*ZH[gt3, 3]*ZH[gt4, 1] + E^(I*"eta")*Lam7*ZH[gt3, 4]*ZH[gt4, 1] - E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt3, 4]*ZH[gt4, 1] - 3*E^(I*"eta")*Lam7*ZH[gt3, 3]*ZH[gt4, 2] + 3*E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt3, 3]*ZH[gt4, 2] - (2*I)*E^((2*I)*"eta")*Lam3*ZH[gt3, 3]*ZH[gt4, 3] - (2*I)*E^((2*I)*"eta")*Lam4*ZH[gt3, 3]*ZH[gt4, 3] + I*E^((4*I)*"eta")*Lam5*ZH[gt3, 3]*ZH[gt4, 3] + I*Conjugate[Lam5]*ZH[gt3, 3]*ZH[gt4, 3] - I*E^(I*"eta")*Lam7*ZH[gt3, 4]*ZH[gt4, 3] - I*E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt3, 4]*ZH[gt4, 3] + 3*E^(I*"eta")*ZH[gt3, 2]*((-I)*(Lam7 + E^((2*I)*"eta")*Conjugate[Lam7])*ZH[gt4, 1] - (4*I)*E^(I*"eta")*Lam2*ZH[gt4, 2] - (Lam7 - E^((2*I)*"eta")*Conjugate[Lam7])*ZH[gt4, 3]) - I*E^(I*"eta")*Lam7*ZH[gt3, 3]*ZH[gt4, 4] - I*E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt3, 3]*ZH[gt4, 4] - (4*I)*E^((2*I)*"eta")*Lam2*ZH[gt3, 4]*ZH[gt4, 4] + ZH[gt3, 1]*((-I)*(E^((2*I)*"eta")*(2*Lam3 + 2*Lam4 + E^((2*I)*"eta")*Lam5) + Conjugate[Lam5])*ZH[gt4, 1] - (3*I)*E^(I*"eta")*(Lam7 + E^((2*I)*"eta")*Conjugate[Lam7])*ZH[gt4, 2] + E^((4*I)*"eta")*Lam5*ZH[gt4, 3] - Conjugate[Lam5]*ZH[gt4, 3] + E^(I*"eta")*Lam7*ZH[gt4, 4] - E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt4, 4])) + ZH[gt2, 1]*(-(E^(I*"eta")*Lam6*ZH[gt3, 3]*ZH[gt4, 1]) + E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt3, 3]*ZH[gt4, 1] - E^((4*I)*"eta")*Lam5*ZH[gt3, 4]*ZH[gt4, 1] + Conjugate[Lam5]*ZH[gt3, 4]*ZH[gt4, 1] + E^((4*I)*"eta")*Lam5*ZH[gt3, 3]*ZH[gt4, 2] - Conjugate[Lam5]*ZH[gt3, 3]*ZH[gt4, 2] + E^(I*"eta")*Lam7*ZH[gt3, 4]*ZH[gt4, 2] - E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt3, 4]*ZH[gt4, 2] - I*E^(I*"eta")*Lam6*ZH[gt3, 3]*ZH[gt4, 3] - I*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt3, 3]*ZH[gt4, 3] - I*E^((4*I)*"eta")*Lam5*ZH[gt3, 4]*ZH[gt4, 3] - I*Conjugate[Lam5]*ZH[gt3, 4]*ZH[gt4, 3] - I*E^((4*I)*"eta")*Lam5*ZH[gt3, 3]*ZH[gt4, 4] - I*Conjugate[Lam5]*ZH[gt3, 3]*ZH[gt4, 4] - I*E^(I*"eta")*Lam7*ZH[gt3, 4]*ZH[gt4, 4] - I*E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt3, 4]*ZH[gt4, 4] + ZH[gt3, 1]*((-3*I)*E^(I*"eta")*(Lam6 + E^((2*I)*"eta")*Conjugate[Lam6])*ZH[gt4, 1] - I*(E^((2*I)*"eta")*(2*Lam3 + 2*Lam4 + E^((2*I)*"eta")*Lam5) + Conjugate[Lam5])*ZH[gt4, 2] - E^(I*"eta")*Lam6*ZH[gt4, 3] + E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt4, 3] - E^((4*I)*"eta")*Lam5*ZH[gt4, 4] + Conjugate[Lam5]*ZH[gt4, 4]) + ZH[gt3, 2]*((-I)*(E^((2*I)*"eta")*(2*Lam3 + 2*Lam4 + E^((2*I)*"eta")*Lam5) + Conjugate[Lam5])*ZH[gt4, 1] - (3*I)*E^(I*"eta")*(Lam7 + E^((2*I)*"eta")*Conjugate[Lam7])*ZH[gt4, 2] + E^((4*I)*"eta")*Lam5*ZH[gt4, 3] - Conjugate[Lam5]*ZH[gt4, 3] + E^(I*"eta")*Lam7*ZH[gt4, 4] - E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt4, 4]))) + ZH[gt1, 1]*(3*E^(I*"eta")*Lam6*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 1] - 3*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 1] - E^(I*"eta")*Lam6*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 1] + E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 1] - E^((4*I)*"eta")*Lam5*ZH[gt2, 4]*ZH[gt3, 2]*ZH[gt4, 1] + Conjugate[Lam5]*ZH[gt2, 4]*ZH[gt3, 2]*ZH[gt4, 1] - (4*I)*E^((2*I)*"eta")*Lam1*ZH[gt2, 3]*ZH[gt3, 3]*ZH[gt4, 1] - I*E^(I*"eta")*Lam6*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 1] - I*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 1] - I*E^(I*"eta")*Lam6*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 1] - I*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 1] - (2*I)*E^((2*I)*"eta")*Lam3*ZH[gt2, 4]*ZH[gt3, 4]*ZH[gt4, 1] - (2*I)*E^((2*I)*"eta")*Lam4*ZH[gt2, 4]*ZH[gt3, 4]*ZH[gt4, 1] + I*E^((4*I)*"eta")*Lam5*ZH[gt2, 4]*ZH[gt3, 4]*ZH[gt4, 1] + I*Conjugate[Lam5]*ZH[gt2, 4]*ZH[gt3, 4]*ZH[gt4, 1] - E^(I*"eta")*Lam6*ZH[gt2, 3]*ZH[gt3, 1]*ZH[gt4, 2] + E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt2, 3]*ZH[gt3, 1]*ZH[gt4, 2] - E^((4*I)*"eta")*Lam5*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 2] + Conjugate[Lam5]*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 2] + E^((4*I)*"eta")*Lam5*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 2] - Conjugate[Lam5]*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 2] + E^(I*"eta")*Lam7*ZH[gt2, 4]*ZH[gt3, 2]*ZH[gt4, 2] - E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt2, 4]*ZH[gt3, 2]*ZH[gt4, 2] - I*E^(I*"eta")*Lam6*ZH[gt2, 3]*ZH[gt3, 3]*ZH[gt4, 2] - I*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt2, 3]*ZH[gt3, 3]*ZH[gt4, 2] - I*E^((4*I)*"eta")*Lam5*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 2] - I*Conjugate[Lam5]*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 2] - I*E^((4*I)*"eta")*Lam5*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 2] - I*Conjugate[Lam5]*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 2] - I*E^(I*"eta")*Lam7*ZH[gt2, 4]*ZH[gt3, 4]*ZH[gt4, 2] - I*E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt2, 4]*ZH[gt3, 4]*ZH[gt4, 2] - (4*I)*E^((2*I)*"eta")*Lam1*ZH[gt2, 3]*ZH[gt3, 1]*ZH[gt4, 3] - I*E^(I*"eta")*Lam6*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 3] - I*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 3] - I*E^(I*"eta")*Lam6*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 3] - I*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 3] - I*E^((4*I)*"eta")*Lam5*ZH[gt2, 4]*ZH[gt3, 2]*ZH[gt4, 3] - I*Conjugate[Lam5]*ZH[gt2, 4]*ZH[gt3, 2]*ZH[gt4, 3] + E^(I*"eta")*Lam6*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 3] - E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 3] + E^(I*"eta")*Lam6*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 3] - E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 3] - E^((4*I)*"eta")*Lam5*ZH[gt2, 4]*ZH[gt3, 4]*ZH[gt4, 3] + Conjugate[Lam5]*ZH[gt2, 4]*ZH[gt3, 4]*ZH[gt4, 3] - I*E^(I*"eta")*Lam6*ZH[gt2, 3]*ZH[gt3, 1]*ZH[gt4, 4] - I*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt2, 3]*ZH[gt3, 1]*ZH[gt4, 4] - (2*I)*E^((2*I)*"eta")*Lam3*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 4] - (2*I)*E^((2*I)*"eta")*Lam4*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 4] + I*E^((4*I)*"eta")*Lam5*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 4] + I*Conjugate[Lam5]*ZH[gt2, 4]*ZH[gt3, 1]*ZH[gt4, 4] - I*E^((4*I)*"eta")*Lam5*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 4] - I*Conjugate[Lam5]*ZH[gt2, 3]*ZH[gt3, 2]*ZH[gt4, 4] - I*E^(I*"eta")*Lam7*ZH[gt2, 4]*ZH[gt3, 2]*ZH[gt4, 4] - I*E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt2, 4]*ZH[gt3, 2]*ZH[gt4, 4] + E^(I*"eta")*Lam6*ZH[gt2, 3]*ZH[gt3, 3]*ZH[gt4, 4] - E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt2, 3]*ZH[gt3, 3]*ZH[gt4, 4] - E^((4*I)*"eta")*Lam5*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 4] + Conjugate[Lam5]*ZH[gt2, 4]*ZH[gt3, 3]*ZH[gt4, 4] - E^((4*I)*"eta")*Lam5*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 4] + Conjugate[Lam5]*ZH[gt2, 3]*ZH[gt3, 4]*ZH[gt4, 4] + 3*E^(I*"eta")*Lam7*ZH[gt2, 4]*ZH[gt3, 4]*ZH[gt4, 4] - 3*E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt2, 4]*ZH[gt3, 4]*ZH[gt4, 4] + ZH[gt2, 1]*(3*E^(I*"eta")*Lam6*ZH[gt3, 4]*ZH[gt4, 1] - 3*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt3, 4]*ZH[gt4, 1] - E^(I*"eta")*Lam6*ZH[gt3, 3]*ZH[gt4, 2] + E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt3, 3]*ZH[gt4, 2] - E^((4*I)*"eta")*Lam5*ZH[gt3, 4]*ZH[gt4, 2] + Conjugate[Lam5]*ZH[gt3, 4]*ZH[gt4, 2] - (4*I)*E^((2*I)*"eta")*Lam1*ZH[gt3, 3]*ZH[gt4, 3] - I*E^(I*"eta")*Lam6*ZH[gt3, 4]*ZH[gt4, 3] - I*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt3, 4]*ZH[gt4, 3] - I*E^(I*"eta")*Lam6*ZH[gt3, 3]*ZH[gt4, 4] - I*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt3, 3]*ZH[gt4, 4] - (2*I)*E^((2*I)*"eta")*Lam3*ZH[gt3, 4]*ZH[gt4, 4] - (2*I)*E^((2*I)*"eta")*Lam4*ZH[gt3, 4]*ZH[gt4, 4] + I*E^((4*I)*"eta")*Lam5*ZH[gt3, 4]*ZH[gt4, 4] + I*Conjugate[Lam5]*ZH[gt3, 4]*ZH[gt4, 4] + ZH[gt3, 2]*((-3*I)*E^(I*"eta")*(Lam6 + E^((2*I)*"eta")*Conjugate[Lam6])*ZH[gt4, 1] - I*(E^((2*I)*"eta")*(2*Lam3 + 2*Lam4 + E^((2*I)*"eta")*Lam5) + Conjugate[Lam5])*ZH[gt4, 2] - E^(I*"eta")*Lam6*ZH[gt4, 3] + E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt4, 3] - E^((4*I)*"eta")*Lam5*ZH[gt4, 4] + Conjugate[Lam5]*ZH[gt4, 4]) + 3*E^(I*"eta")*ZH[gt3, 1]*((-4*I)*E^(I*"eta")*Lam1*ZH[gt4, 1] - I*(Lam6 + E^((2*I)*"eta")*Conjugate[Lam6])*ZH[gt4, 2] + (Lam6 - E^((2*I)*"eta")*Conjugate[Lam6])*ZH[gt4, 4])) + ZH[gt2, 2]*(-(E^(I*"eta")*Lam6*ZH[gt3, 3]*ZH[gt4, 1]) + E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt3, 3]*ZH[gt4, 1] - E^((4*I)*"eta")*Lam5*ZH[gt3, 4]*ZH[gt4, 1] + Conjugate[Lam5]*ZH[gt3, 4]*ZH[gt4, 1] + E^((4*I)*"eta")*Lam5*ZH[gt3, 3]*ZH[gt4, 2] - Conjugate[Lam5]*ZH[gt3, 3]*ZH[gt4, 2] + E^(I*"eta")*Lam7*ZH[gt3, 4]*ZH[gt4, 2] - E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt3, 4]*ZH[gt4, 2] - I*E^(I*"eta")*Lam6*ZH[gt3, 3]*ZH[gt4, 3] - I*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt3, 3]*ZH[gt4, 3] - I*E^((4*I)*"eta")*Lam5*ZH[gt3, 4]*ZH[gt4, 3] - I*Conjugate[Lam5]*ZH[gt3, 4]*ZH[gt4, 3] - I*E^((4*I)*"eta")*Lam5*ZH[gt3, 3]*ZH[gt4, 4] - I*Conjugate[Lam5]*ZH[gt3, 3]*ZH[gt4, 4] - I*E^(I*"eta")*Lam7*ZH[gt3, 4]*ZH[gt4, 4] - I*E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt3, 4]*ZH[gt4, 4] + ZH[gt3, 1]*((-3*I)*E^(I*"eta")*(Lam6 + E^((2*I)*"eta")*Conjugate[Lam6])*ZH[gt4, 1] - I*(E^((2*I)*"eta")*(2*Lam3 + 2*Lam4 + E^((2*I)*"eta")*Lam5) + Conjugate[Lam5])*ZH[gt4, 2] - E^(I*"eta")*Lam6*ZH[gt4, 3] + E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt4, 3] - E^((4*I)*"eta")*Lam5*ZH[gt4, 4] + Conjugate[Lam5]*ZH[gt4, 4]) + ZH[gt3, 2]*((-I)*(E^((2*I)*"eta")*(2*Lam3 + 2*Lam4 + E^((2*I)*"eta")*Lam5) + Conjugate[Lam5])*ZH[gt4, 1] - (3*I)*E^(I*"eta")*(Lam7 + E^((2*I)*"eta")*Conjugate[Lam7])*ZH[gt4, 2] + E^((4*I)*"eta")*Lam5*ZH[gt4, 3] - Conjugate[Lam5]*ZH[gt4, 3] + E^(I*"eta")*Lam7*ZH[gt4, 4] - E^((3*I)*"eta")*Conjugate[Lam7]*ZH[gt4, 4]))))/(2*E^((2*I)*"eta"))}},
 C[S[1, {gt1}], S[1, {gt2}], S[3, {gt3}], -S[3, {gt4}]] == {{(Conjugate[ZP[gt3, 1]]*(E^(I*"eta")*Lam6*ZH[gt1, 4]*ZH[gt2, 1]*ZP[gt4, 1] - E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 4]*ZH[gt2, 1]*ZP[gt4, 1] - E^(I*"eta")*Lam6*ZH[gt1, 3]*ZH[gt2, 2]*ZP[gt4, 1] + E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 2]*ZP[gt4, 1] - (4*I)*E^((2*I)*"eta")*Lam1*ZH[gt1, 3]*ZH[gt2, 3]*ZP[gt4, 1] - I*E^(I*"eta")*Lam6*ZH[gt1, 4]*ZH[gt2, 3]*ZP[gt4, 1] - I*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 4]*ZH[gt2, 3]*ZP[gt4, 1] - I*E^(I*"eta")*Lam6*ZH[gt1, 3]*ZH[gt2, 4]*ZP[gt4, 1] - I*E^((3*I)*"eta")*Conjugate[Lam6]*ZH[gt1, 3]*ZH[gt2, 4]*ZP[gt4, 1] - (2*I)*E^((2*I)*"eta")*Lam3*ZH[gt1, 4]*ZH[gt2, 4]*ZP[gt4, 1] - E^((2*I)*"eta")*Lam4*ZH[gt1, 4]*ZH[gt2, 1]*ZP[gt4, 2] + Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 1]*ZP[gt4, 2] + E^((2*I)*"eta")*Lam4*ZH[gt1, 3]*ZH[gt2, 2]*ZP[gt4, 2] - Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 2]*ZP[gt4, 2] - (2*I)*E^(I*"eta")*Lam6*ZH[gt1, 3]*ZH[gt2, 3]*ZP[gt4, 2] - I*E^((2*I)*"eta")*Lam4*ZH[gt1, 4]*ZH[gt2, 3]*ZP[gt4, 2] - I*Conjugate[Lam5]*ZH[gt1, 4]*ZH[gt2, 3]*ZP[gt4, 2] - I*E^((2*I)*"eta")*Lam4*ZH[gt1, 3]*ZH[gt2, 4]*ZP[gt4, 2] - I*Conjugate[Lam5]*ZH[gt1, 3]*ZH[gt2, 4]*ZP[gt4, 2] - (2*I)*E^(I*"eta")*Lam7*ZH[gt1, 4]*ZH[gt2, 4]*ZP[gt4, 2] + ZH[gt1, 2]*((-2*I)*E^(I*"eta")*ZH[gt2, 2]*(E^(I*"eta")*Lam3*ZP[gt4, 1] + Lam7*ZP[gt4, 2]) + ZH[gt2, 3]*(E^(I*"eta")*(-Lam6 + E^((2*I)*"eta")*Conjugate[Lam6])*ZP[gt4, 1] + (E^((2*I)*"eta")*Lam4 - Conjugate[Lam5])*ZP[gt4, 2]) - I*ZH[gt2, 1]*(E^(I*"eta")*(Lam6 + E^((2*I)*"eta")*Conjugate[Lam6])*ZP[gt4, 1] + (E^((2*I)*"eta")*Lam4 + Conjugate[Lam5])*ZP[gt4, 2])) + ZH[gt1, 1]*((-2*I)*E^(I*"eta")*ZH[gt2, 1]*(2*E^(I*"eta")*Lam1*ZP[gt4, 1] + Lam6*ZP[gt4, 2]) - ZH[gt2, 4]*(E^(I*"eta")*(-Lam6 + E^((2*I)*"eta")*Conjugate[Lam6])*ZP[gt4, 1] + (E^((2*I)*"eta")*Lam4 - Conjugate[Lam5])*ZP[gt4, 2]) - I*ZH[gt2, 2]*(E^(I*"eta")*(Lam6 + E^((2*I)*"eta")*Conjugate[Lam6])*ZP[gt4, 1] + (E^((2*I)*"eta")*Lam4 + Conjugate[Lam5])*ZP[gt4, 2]))) + E^(I*"eta")*Conjugate[ZP[gt3, 2]]*(E^(I*"eta")*Lam4*ZH[gt1, 4]*ZH[gt2, 1]*ZP[gt4, 1] - E^((3*I)*"eta")*Lam5*ZH[gt1, 4]*ZH[gt2, 1]*ZP[gt4, 1] - I*E^(I*"eta")*Lam4*ZH[gt1, 1]*ZH[gt2, 2]*ZP[gt4, 1] - I*E^((3*I)*"eta")*Lam5*ZH[gt1, 1]*ZH[gt2, 2]*ZP[gt4, 1] - E^(I*"eta")*Lam4*ZH[gt1, 3]*ZH[gt2, 2]*ZP[gt4, 1] + E^((3*I)*"eta")*Lam5*ZH[gt1, 3]*ZH[gt2, 2]*ZP[gt4, 1] - I*E^(I*"eta")*Lam4*ZH[gt1, 4]*ZH[gt2, 3]*ZP[gt4, 1] - I*E^((3*I)*"eta")*Lam5*ZH[gt1, 4]*ZH[gt2, 3]*ZP[gt4, 1] - (2*I)*E^((2*I)*"eta")*Conjugate[Lam6]*(ZH[gt1, 1]*ZH[gt2, 1] + ZH[gt1, 3]*ZH[gt2, 3])*ZP[gt4, 1] + E^(I*"eta")*Lam4*ZH[gt1, 1]*ZH[gt2, 4]*ZP[gt4, 1] - E^((3*I)*"eta")*Lam5*ZH[gt1, 1]*ZH[gt2, 4]*ZP[gt4, 1] - I*E^(I*"eta")*Lam4*ZH[gt1, 3]*ZH[gt2, 4]*ZP[gt4, 1] - I*E^((3*I)*"eta")*Lam5*ZH[gt1, 3]*ZH[gt2, 4]*ZP[gt4, 1] - (2*I)*E^((2*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 4]*ZP[gt4, 1] - (2*I)*E^(I*"eta")*Lam3*ZH[gt1, 1]*ZH[gt2, 1]*ZP[gt4, 2] + Lam7*ZH[gt1, 4]*ZH[gt2, 1]*ZP[gt4, 2] - E^((2*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 1]*ZP[gt4, 2] - I*Lam7*ZH[gt1, 1]*ZH[gt2, 2]*ZP[gt4, 2] - I*E^((2*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 1]*ZH[gt2, 2]*ZP[gt4, 2] - Lam7*ZH[gt1, 3]*ZH[gt2, 2]*ZP[gt4, 2] + E^((2*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 3]*ZH[gt2, 2]*ZP[gt4, 2] - (2*I)*E^(I*"eta")*Lam3*ZH[gt1, 3]*ZH[gt2, 3]*ZP[gt4, 2] - I*Lam7*ZH[gt1, 4]*ZH[gt2, 3]*ZP[gt4, 2] - I*E^((2*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 4]*ZH[gt2, 3]*ZP[gt4, 2] + Lam7*ZH[gt1, 1]*ZH[gt2, 4]*ZP[gt4, 2] - E^((2*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 1]*ZH[gt2, 4]*ZP[gt4, 2] - I*Lam7*ZH[gt1, 3]*ZH[gt2, 4]*ZP[gt4, 2] - I*E^((2*I)*"eta")*Conjugate[Lam7]*ZH[gt1, 3]*ZH[gt2, 4]*ZP[gt4, 2] - (4*I)*E^(I*"eta")*Lam2*ZH[gt1, 4]*ZH[gt2, 4]*ZP[gt4, 2] + ZH[gt1, 2]*(-(E^(I*"eta")*Lam4*ZH[gt2, 3]*ZP[gt4, 1]) + E^((3*I)*"eta")*Lam5*ZH[gt2, 3]*ZP[gt4, 1] - (4*I)*E^(I*"eta")*Lam2*ZH[gt2, 2]*ZP[gt4, 2] - Lam7*ZH[gt2, 3]*ZP[gt4, 2] - I*ZH[gt2, 1]*(E^(I*"eta")*(Lam4 + E^((2*I)*"eta")*Lam5)*ZP[gt4, 1] + (Lam7 + E^((2*I)*"eta")*Conjugate[Lam7])*ZP[gt4, 2]) + E^((2*I)*"eta")*Conjugate[Lam7]*((-2*I)*ZH[gt2, 2]*ZP[gt4, 1] + ZH[gt2, 3]*ZP[gt4, 2]))))/(2*E^((2*I)*"eta"))}},
 C[S[3, {gt1}], S[3, {gt2}], -S[3, {gt3}], -S[3, {gt4}]] == {{((-I)*(Conjugate[ZP[gt1, 1]]*(E^(I*"eta")*Conjugate[ZP[gt2, 2]]*(2*E^((2*I)*"eta")*Conjugate[Lam6]*ZP[gt3, 1]*ZP[gt4, 1] + E^(I*"eta")*(Lam3 + Lam4)*ZP[gt3, 1]*ZP[gt4, 2] + ZP[gt3, 2]*(E^(I*"eta")*(Lam3 + Lam4)*ZP[gt4, 1] + 2*Lam7*ZP[gt4, 2])) + 2*Conjugate[ZP[gt2, 1]]*(E^(I*"eta")*ZP[gt3, 1]*(2*E^(I*"eta")*Lam1*ZP[gt4, 1] + Lam6*ZP[gt4, 2]) + ZP[gt3, 2]*(E^(I*"eta")*Lam6*ZP[gt4, 1] + Conjugate[Lam5]*ZP[gt4, 2]))) + E^(I*"eta")*Conjugate[ZP[gt1, 2]]*(2*E^((2*I)*"eta")*Conjugate[Lam6]*Conjugate[ZP[gt2, 1]]*ZP[gt3, 1]*ZP[gt4, 1] + Conjugate[ZP[gt2, 1]]*(E^(I*"eta")*(Lam3 + Lam4)*ZP[gt3, 1]*ZP[gt4, 2] + ZP[gt3, 2]*(E^(I*"eta")*(Lam3 + Lam4)*ZP[gt4, 1] + 2*Lam7*ZP[gt4, 2])) + 2*E^(I*"eta")*Conjugate[ZP[gt2, 2]]*(ZP[gt3, 2]*(E^(I*"eta")*Conjugate[Lam7]*ZP[gt4, 1] + 2*Lam2*ZP[gt4, 2]) + E^(I*"eta")*ZP[gt3, 1]*(E^(I*"eta")*Lam5*ZP[gt4, 1] + Conjugate[Lam7]*ZP[gt4, 2])))))/E^((2*I)*"eta")}},
 C[V[5, {ct1}], V[5, {ct2}], V[5, {ct3}]] == {{g3*fSU3[ct1, ct2, ct3]}},
 C[-V[3], V[1], V[3]] == {{I*g2*STW}},
 C[-V[3], V[3], V[2]] == {{(-I)*CTW*g2}},
 C[S[1, {gt3}], -U[2], U[1]] == {{(I/8)*(2*C2TW*g1*g2 + (g1^2 - g2^2)*S2TW)*GaugeXi[Z]*(vd*ZH[gt3, 1] + vu*ZH[gt3, 2])}},
 C[S[3, {gt3}], -U[3], U[1]] == {{(-I/4)*g2*(CTW*g1 + g2*STW)*(vd*Conjugate[ZP[gt3, 1]] + vu*Conjugate[ZP[gt3, 2]])*GaugeXi[Wm]}},
 C[-S[3, {gt3}], -U[4], U[1]] == {{(-I/4)*g2*(CTW*g1 + g2*STW)*GaugeXi[Wm]*(vd*ZP[gt3, 1] + vu*ZP[gt3, 2])}},
 C[S[1, {gt3}], -U[3], U[3]] == {{(-I/4)*g2^2*GaugeXi[Wm]*(vd*ZH[gt3, 1] + vu*ZH[gt3, 2] - I*(vd*ZH[gt3, 3] + vu*ZH[gt3, 4]))}},
 C[-S[3, {gt3}], -U[2], U[3]] == {{(I/4)*g2*(CTW*g2 + g1*STW)*GaugeXi[Z]*(vd*ZP[gt3, 1] + vu*ZP[gt3, 2])}},
 C[S[1, {gt3}], -U[4], U[4]] == {{(g2^2*GaugeXi[Wm]*((-I)*vd*ZH[gt3, 1] - I*vu*ZH[gt3, 2] + vd*ZH[gt3, 3] + vu*ZH[gt3, 4]))/4}},
 C[S[3, {gt3}], -U[2], U[4]] == {{(I/4)*g2*(CTW*g2 + g1*STW)*(vd*Conjugate[ZP[gt3, 1]] + vu*Conjugate[ZP[gt3, 2]])*GaugeXi[Z]}},
 C[S[1, {gt3}], -U[2], U[2]] == {{(-I/4)*(CTW*g2 + g1*STW)^2*GaugeXi[Z]*(vd*ZH[gt3, 1] + vu*ZH[gt3, 2])}},
 C[S[3, {gt3}], -U[3], U[2]] == {{(-I/4)*g2*(CTW*g2 - g1*STW)*(vd*Conjugate[ZP[gt3, 1]] + vu*Conjugate[ZP[gt3, 2]])*GaugeXi[Wm]}},
 C[-S[3, {gt3}], -U[4], U[2]] == {{(-I/4)*g2*(CTW*g2 - g1*STW)*GaugeXi[Wm]*(vd*ZP[gt3, 1] + vu*ZP[gt3, 2])}},
 C[-U[5, {ct1}], U[5, {ct2}], V[5, {ct3}]] == {{g3*fSU3[ct1, ct2, ct3]}, {0}},
 C[-U[3], U[1], V[3]] == {{I*g2*STW}, {0}},
 C[-U[4], U[1], -V[3]] == {{(-I)*g2*STW}, {0}},
 C[-U[3], U[3], V[1]] == {{(-I)*g2*STW}, {0}},
 C[-U[3], U[3], V[2]] == {{(-I)*CTW*g2}, {0}},
 C[-U[1], U[3], -V[3]] == {{I*g2*STW}, {0}},
 C[-U[2], U[3], -V[3]] == {{I*CTW*g2}, {0}},
 C[-U[4], U[4], V[1]] == {{I*g2*STW}, {0}},
 C[-U[1], U[4], V[3]] == {{(-I)*g2*STW}, {0}},
 C[-U[2], U[4], V[3]] == {{(-I)*CTW*g2}, {0}},
 C[-U[4], U[4], V[2]] == {{I*CTW*g2}, {0}},
 C[-U[3], U[2], V[3]] == {{I*CTW*g2}, {0}},
 C[-U[4], U[2], -V[3]] == {{(-I)*CTW*g2}, {0}}
 }

 
Conjugate[g1] ^= g1; 
Conjugate[g2] ^= g2; 
Conjugate[g3] ^= g3; 
Conjugate[ZZ[a___]] ^= ZZ[a]; 
Conjugate[ZH[a___]] ^= ZH[a]; 
Conjugate[aEWinv] ^= aEWinv; 
Conjugate[v] ^= v; 
Conjugate[Gf] ^= Gf; 
