! -----------------------------------------------------------------------------  
! This file was automatically created by SARAH version 4.6.0 
! SARAH References: arXiv:0806.0538, 0909.2863, 1002.0840, 1207.0906, 1309.7223  
! (c) Florian Staub, 2013  
! ------------------------------------------------------------------------------  
! File created at 21:52 on 18.11.2015   
! ----------------------------------------------------------------------  
 
 
Module Tadpoles_THDMCPV 
 
Use Model_Data_THDMCPV 
Use SUSYMasses_THDMCPV 
Use RGEs_THDMCPV 
Use Control 

Use Mathematics 

Contains 


Subroutine SolveTadpoleEquations(g1,g2,g3,Lam6,Lam5,Lam7,Lam1,Lam4,Lam3,              & 
& Lam2,epsU,Yu,Yd,Ye,epsD,epsE,M12,M112,M222,vd,vu,Tad1Loop)

Implicit None
Real(dp),Intent(inout) :: g1,g2,g3,vd,vu

Complex(dp),Intent(inout) :: Lam6,Lam5,Lam7,Lam1,Lam4,Lam3,Lam2,epsU(3,3),Yu(3,3),Yd(3,3),Ye(3,3),epsD(3,3),       & 
& epsE(3,3),M12,M112,M222

Complex(dp), Intent(in) :: Tad1Loop(4)

! For numerical routines 
Real(dp) :: gC(133)
logical :: broycheck 
Real(dp) :: broyx(3)

If (HighScaleModel.Eq."LOW") Then 
M112 = -(2*Lam1*vd**3 + 2*exp(2*(0.,1._dp)*eta)*Lam1*vd**3 + (Lam6*vd**2*vu)/exp((0._dp,     & 
& 1._dp)*eta) + 2*exp((0._dp,1._dp)*eta)*Lam6*vd**2*vu + Lam3*vd*vu**2 + exp(2*(0.,      & 
& 1._dp)*eta)*Lam3*vd*vu**2 + Lam4*vd*vu**2 + exp(2*(0.,1._dp)*eta)*Lam4*vd*vu**2 +      & 
&  exp(2*(0.,1._dp)*eta)*Lam5*vd*vu**2 + exp((0._dp,1._dp)*eta)*Lam7*vu**3 +             & 
&  vd*vu**2*Conjg(Lam5) + exp((0._dp,1._dp)*eta)*(2 + exp(2*(0.,1._dp)*eta))*vd**2*vu*Conjg(Lam6) +& 
&  exp((0._dp,1._dp)*eta)*vu**3*Conjg(Lam7) - 4*exp((0._dp,1._dp)*eta)*vu*Real(M12,      & 
& dp) - 2*Tad1Loop(1) - 2*exp(2*(0.,1._dp)*eta)*Tad1Loop(1) + 2*(0.,1._dp)*Tad1Loop(3) - & 
&  2*(0.,1._dp)*exp(2*(0.,1._dp)*eta)*Tad1Loop(3))/(2._dp*(1 + exp(2*(0.,1._dp)*eta))*vd)
M222 = -(exp((0._dp,1._dp)*eta)*Lam6*vd**3*vu + Lam3*vd**2*vu**2 + exp(2*(0.,1._dp)*eta)*Lam3*vd**2*vu**2 +& 
&  Lam4*vd**2*vu**2 + exp(2*(0.,1._dp)*eta)*Lam4*vd**2*vu**2 + exp(2*(0.,1._dp)*eta)*Lam5*vd**2*vu**2 +& 
&  (Lam7*vd*vu**3)/exp((0._dp,1._dp)*eta) + 2*exp((0._dp,1._dp)*eta)*Lam7*vd*vu**3 +     & 
&  2*Lam2*vu**4 + 2*exp(2*(0.,1._dp)*eta)*Lam2*vu**4 + vd**2*vu**2*Conjg(Lam5) +         & 
&  exp((0._dp,1._dp)*eta)*vd**3*vu*Conjg(Lam6) + 2*exp((0._dp,1._dp)*eta)*vd*vu**3*Conjg(Lam7) +& 
&  exp(3*(0.,1._dp)*eta)*vd*vu**3*Conjg(Lam7) - 4*exp((0._dp,1._dp)*eta)*vd*vu*Real(M12, & 
& dp) - 2*vu*Tad1Loop(2) - 2*exp(2*(0.,1._dp)*eta)*vu*Tad1Loop(2) + 2*(0.,               & 
& 1._dp)*vd*Tad1Loop(3) - 2*(0.,1._dp)*exp(2*(0.,1._dp)*eta)*vd*Tad1Loop(3))/(2._dp*(1 + & 
&  exp(2*(0.,1._dp)*eta))*vu**2)
temporaryValue = (1._dp/2._dp*(0.,1._dp)*(-(vd*vu**2*Conjg(Lam5)) + exp((0._dp,1._dp)*eta)*(-          & 
& (Lam6*vd**2*vu) + exp(3*(0.,1._dp)*eta)*Lam5*vd*vu**2 - Lam7*vu**3 + exp(2*(0.,        & 
& 1._dp)*eta)*vd**2*vu*Conjg(Lam6) + exp(2*(0.,1._dp)*eta)*vu**3*Conjg(Lam7) +           & 
&  2*vu*Real(M12,dp) - 2*exp(2*(0.,1._dp)*eta)*vu*Real(M12,dp) + 4*(0.,1._dp)*exp((0._dp,& 
& 1._dp)*eta)*Tad1Loop(3))))/(exp((0._dp,1._dp)*eta)*(1 + exp(2*(0.,1._dp)*eta))*vu)
M12 = Cmplx(real(M12,dp),Real(temporaryValue,dp),dp) 

 ! ----------- Check solutions for consistency  -------- 

 ! Check for NaNs 
If (Real(M112,dp).ne.Real(M112,dp)) Then 
   Write(*,*) "NaN appearing in solution of tadpole equations for M112" 
   Call TerminateProgram  
 End If 
 If (Abs(AImag(M112)).gt.1.0E-04_dp) Then 
   Write(*,*) "No real solution of tadpole equations for M112" 
   !Call TerminateProgram  
   M112 = Real(M112,dp) 
  SignOfMuChanged= .True. 
End If 
 If (Real(M222,dp).ne.Real(M222,dp)) Then 
   Write(*,*) "NaN appearing in solution of tadpole equations for M222" 
   Call TerminateProgram  
 End If 
 If (Abs(AImag(M222)).gt.1.0E-04_dp) Then 
   Write(*,*) "No real solution of tadpole equations for M222" 
   !Call TerminateProgram  
   M222 = Real(M222,dp) 
  SignOfMuChanged= .True. 
End If 
 If (Real(M12,dp).ne.Real(M12,dp)) Then 
   Write(*,*) "NaN appearing in solution of tadpole equations for M12" 
   Call TerminateProgram  
 End If 
 Else 
M112 = -(2*Lam1*vd**3 + 2*exp(2*(0.,1._dp)*eta)*Lam1*vd**3 + (Lam6*vd**2*vu)/exp((0._dp,     & 
& 1._dp)*eta) + 2*exp((0._dp,1._dp)*eta)*Lam6*vd**2*vu + Lam3*vd*vu**2 + exp(2*(0.,      & 
& 1._dp)*eta)*Lam3*vd*vu**2 + Lam4*vd*vu**2 + exp(2*(0.,1._dp)*eta)*Lam4*vd*vu**2 +      & 
&  exp(2*(0.,1._dp)*eta)*Lam5*vd*vu**2 + exp((0._dp,1._dp)*eta)*Lam7*vu**3 +             & 
&  vd*vu**2*Conjg(Lam5) + exp((0._dp,1._dp)*eta)*(2 + exp(2*(0.,1._dp)*eta))*vd**2*vu*Conjg(Lam6) +& 
&  exp((0._dp,1._dp)*eta)*vu**3*Conjg(Lam7) - 4*exp((0._dp,1._dp)*eta)*vu*Real(M12,      & 
& dp) - 2*Tad1Loop(1) - 2*exp(2*(0.,1._dp)*eta)*Tad1Loop(1) + 2*(0.,1._dp)*Tad1Loop(3) - & 
&  2*(0.,1._dp)*exp(2*(0.,1._dp)*eta)*Tad1Loop(3))/(2._dp*(1 + exp(2*(0.,1._dp)*eta))*vd)
M222 = -(exp((0._dp,1._dp)*eta)*Lam6*vd**3*vu + Lam3*vd**2*vu**2 + exp(2*(0.,1._dp)*eta)*Lam3*vd**2*vu**2 +& 
&  Lam4*vd**2*vu**2 + exp(2*(0.,1._dp)*eta)*Lam4*vd**2*vu**2 + exp(2*(0.,1._dp)*eta)*Lam5*vd**2*vu**2 +& 
&  (Lam7*vd*vu**3)/exp((0._dp,1._dp)*eta) + 2*exp((0._dp,1._dp)*eta)*Lam7*vd*vu**3 +     & 
&  2*Lam2*vu**4 + 2*exp(2*(0.,1._dp)*eta)*Lam2*vu**4 + vd**2*vu**2*Conjg(Lam5) +         & 
&  exp((0._dp,1._dp)*eta)*vd**3*vu*Conjg(Lam6) + 2*exp((0._dp,1._dp)*eta)*vd*vu**3*Conjg(Lam7) +& 
&  exp(3*(0.,1._dp)*eta)*vd*vu**3*Conjg(Lam7) - 4*exp((0._dp,1._dp)*eta)*vd*vu*Real(M12, & 
& dp) - 2*vu*Tad1Loop(2) - 2*exp(2*(0.,1._dp)*eta)*vu*Tad1Loop(2) + 2*(0.,               & 
& 1._dp)*vd*Tad1Loop(3) - 2*(0.,1._dp)*exp(2*(0.,1._dp)*eta)*vd*Tad1Loop(3))/(2._dp*(1 + & 
&  exp(2*(0.,1._dp)*eta))*vu**2)
temporaryValue = (1._dp/2._dp*(0.,1._dp)*(-(vd*vu**2*Conjg(Lam5)) + exp((0._dp,1._dp)*eta)*(-          & 
& (Lam6*vd**2*vu) + exp(3*(0.,1._dp)*eta)*Lam5*vd*vu**2 - Lam7*vu**3 + exp(2*(0.,        & 
& 1._dp)*eta)*vd**2*vu*Conjg(Lam6) + exp(2*(0.,1._dp)*eta)*vu**3*Conjg(Lam7) +           & 
&  2*vu*Real(M12,dp) - 2*exp(2*(0.,1._dp)*eta)*vu*Real(M12,dp) + 4*(0.,1._dp)*exp((0._dp,& 
& 1._dp)*eta)*Tad1Loop(3))))/(exp((0._dp,1._dp)*eta)*(1 + exp(2*(0.,1._dp)*eta))*vu)
M12 = Cmplx(real(M12,dp),Real(temporaryValue,dp),dp) 

 ! ----------- Check solutions for consistency  -------- 

 ! Check for NaNs 
If (Real(M112,dp).ne.Real(M112,dp)) Then 
   Write(*,*) "NaN appearing in solution of tadpole equations for M112" 
   Call TerminateProgram  
 End If 
 If (Abs(AImag(M112)).gt.1.0E-04_dp) Then 
   Write(*,*) "No real solution of tadpole equations for M112" 
   !Call TerminateProgram  
   M112 = Real(M112,dp) 
  SignOfMuChanged= .True. 
End If 
 If (Real(M222,dp).ne.Real(M222,dp)) Then 
   Write(*,*) "NaN appearing in solution of tadpole equations for M222" 
   Call TerminateProgram  
 End If 
 If (Abs(AImag(M222)).gt.1.0E-04_dp) Then 
   Write(*,*) "No real solution of tadpole equations for M222" 
   !Call TerminateProgram  
   M222 = Real(M222,dp) 
  SignOfMuChanged= .True. 
End If 
 If (Real(M12,dp).ne.Real(M12,dp)) Then 
   Write(*,*) "NaN appearing in solution of tadpole equations for M12" 
   Call TerminateProgram  
 End If 
 End if 
End Subroutine SolveTadpoleEquations

Subroutine CalculateTadpoles(g1,g2,g3,Lam6,Lam5,Lam7,Lam1,Lam4,Lam3,Lam2,             & 
& epsU,Yu,Yd,Ye,epsD,epsE,M12,M112,M222,vd,vu,Tad1Loop,TadpoleValues)

Real(dp),Intent(in) :: g1,g2,g3,vd,vu

Complex(dp),Intent(in) :: Lam6,Lam5,Lam7,Lam1,Lam4,Lam3,Lam2,epsU(3,3),Yu(3,3),Yd(3,3),Ye(3,3),epsD(3,3),       & 
& epsE(3,3),M12,M112,M222

Complex(dp), Intent(in) :: Tad1Loop(4)

Real(dp), Intent(out) :: TadpoleValues(4)

TadpoleValues(1) = Real((4*exp(2*(0.,1._dp)*eta)*Lam1*vd**3 + vd*(4*exp(2*(0.,1._dp)  & 
& *eta)*M112 + vu**2*(exp(2*(0.,1._dp)*eta)*(2._dp*(Lam3) + 2._dp*(Lam4) + exp(2*(0.,1._dp)& 
& *eta)*Lam5) + Conjg(Lam5))) + 3*exp((0._dp,1._dp)*eta)*vd**2*vu*(Lam6 + exp(2*(0.,1._dp)& 
& *eta)*Conjg(Lam6)) + exp((0._dp,1._dp)*eta)*vu*(-2*exp(2*(0.,1._dp)*eta)               & 
& *(-1*(0.,1._dp)*imM12 + reM12) - 2*((0._dp,1._dp)*imM12 + reM12) + vu**2*(Lam7 + exp(2*(0.,1._dp)& 
& *eta)*Conjg(Lam7))))/(4._dp*exp(2*(0.,1._dp)*eta)) - Tad1Loop(1),dp) 
TadpoleValues(2) = Real((4*exp(2*(0.,1._dp)*eta)*vu*(M222 + Lam2*vu**2)               & 
&  + vd**2*vu*(exp(2*(0.,1._dp)*eta)*(2._dp*(Lam3) + 2._dp*(Lam4) + exp(2*(0.,1._dp)     & 
& *eta)*Lam5) + Conjg(Lam5)) + exp((0._dp,1._dp)*eta)*vd**3*(Lam6 + exp(2*(0.,1._dp)     & 
& *eta)*Conjg(Lam6)) - exp((0._dp,1._dp)*eta)*vd*(2*exp(2*(0.,1._dp)*eta)*(-1*(0.,1._dp) & 
& *imM12 + reM12) + 2*((0._dp,1._dp)*imM12 + reM12) - 3*vu**2*(Lam7 + exp(2*(0.,1._dp)   & 
& *eta)*Conjg(Lam7))))/(4._dp*exp(2*(0.,1._dp)*eta)) - Tad1Loop(2),dp) 
TadpoleValues(3) = Real((1._dp/4._dp*(0.,1._dp)*vu*(-2*exp(3*(0.,1._dp)               & 
& *eta)*(-1*(0.,1._dp)*imM12 + reM12) + vd*vu*(exp(4*(0.,1._dp)*eta)*Lam5 - Conjg(Lam5)) & 
&  + exp((0._dp,1._dp)*eta)*vd**2*(-1._dp*(Lam6) + exp(2*(0.,1._dp)*eta)*Conjg(Lam6))    & 
&  + exp((0._dp,1._dp)*eta)*(2*((0._dp,1._dp)*imM12 + reM12) + vu**2*(-1._dp*(Lam7)      & 
&  + exp(2*(0.,1._dp)*eta)*Conjg(Lam7)))))/exp(2*(0.,1._dp)*eta) - Tad1Loop(3),dp) 
TadpoleValues(4) = Real((-1._dp/4._dp*(0.,1._dp)*vd*(-2*exp(3*(0.,1._dp)              & 
& *eta)*(-1*(0.,1._dp)*imM12 + reM12) + vd*vu*(exp(4*(0.,1._dp)*eta)*Lam5 - Conjg(Lam5)) & 
&  + exp((0._dp,1._dp)*eta)*vd**2*(-1._dp*(Lam6) + exp(2*(0.,1._dp)*eta)*Conjg(Lam6))    & 
&  + exp((0._dp,1._dp)*eta)*(2*((0._dp,1._dp)*imM12 + reM12) + vu**2*(-1._dp*(Lam7)      & 
&  + exp(2*(0.,1._dp)*eta)*Conjg(Lam7)))))/exp(2*(0.,1._dp)*eta) + (vd*Tad1Loop(3))/vu,dp) 
End Subroutine CalculateTadpoles 

End Module Tadpoles_THDMCPV 
 
